/*
    Start Date:   12/03/04
    Last Update:  12/04/04
*/

//#include <stdio.h>
//#include <iostream.h>
//#include <conio.h>

/*
#include "D:\TIGCC\Projects\Blocks\globals.h"
#include "D:\TIGCC\Projects\Blocks\glob_var.h"
*/

#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\globals.h"
#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\glob_var.h"


//00000000000000000000000000000000000000000000000000000000000000000000000

 static const char L_Tetrad [TETRAD_PIC_WIDTH][TETRAD_PIC_WIDTH] =
            {
              { 0, 0, 0, 0,},
              { 0, 1, 0, 0 },
              { 0, 1, 0, 0 },
              { 0, 1, 1, 0 },
            };

 static const char T_Tetrad [TETRAD_PIC_WIDTH][TETRAD_PIC_WIDTH] =
            {
              { 0, 0, 0, 0,},
              { 0, 2, 0, 0 },
              { 2, 2, 2, 0 },
              { 0, 0, 0, 0 },
            };

 static const char Long_Tetrad_1 [TETRAD_PIC_WIDTH][TETRAD_PIC_WIDTH] =
            {
              { 0, 3, 0, 0,},
              { 0, 3, 0, 0 },
              { 0, 3, 0, 0 },
              { 0, 3, 0, 0 },
            };

 static const char Long_Tetrad_2 [TETRAD_PIC_WIDTH][TETRAD_PIC_WIDTH] =
            {
              { 0, 0, 0, 0,},
              { 0, 0, 0, 0 },
              { 3, 3, 3, 3 },
              { 0, 0, 0, 0 },
            };

 static const char Square_Tetrad [TETRAD_PIC_WIDTH][TETRAD_PIC_WIDTH] =
            {
              { 0, 0, 0, 0,},
              { 0, 4, 4, 0 },
              { 0, 4, 4, 0 },
              { 0, 0, 0, 0 },
            };

 static const char Z_Tetrad_1 [TETRAD_PIC_WIDTH][TETRAD_PIC_WIDTH] =
            {
              { 0, 0, 0, 0,},
              { 5, 5, 0, 0 },
              { 0, 5, 5, 0 },
              { 0, 0, 0, 0 },
            };

 static const char Z_Tetrad_2 [TETRAD_PIC_WIDTH][TETRAD_PIC_WIDTH] =
            {
              { 0, 0, 0, 0,},
              { 0, 6, 6, 0 },
              { 6, 6, 0, 0 },
              { 0, 0, 0, 0 },
            };

 //  * * * Unconventional Shapes * * *

 static const char Short_Tetrad [TETRAD_PIC_WIDTH][TETRAD_PIC_WIDTH] =
            {
              { 0, 0, 0, 0,},
              { 0, 0, 0, 0 },
              { 7, 7, 0, 0 },
              { 0, 0, 0, 0 },
            };

 static const char Short_L_Tetrad [TETRAD_PIC_WIDTH][TETRAD_PIC_WIDTH] =
            {
              { 0, 0, 0, 0,},
              { 0, 8, 0, 0 },
              { 0, 8, 8, 0 },
              { 0, 0, 0, 0 },
            };
  static const char C_Tetrad [TETRAD_PIC_WIDTH][TETRAD_PIC_WIDTH] =
            {
              { 0, 0, 0, 0,},
              { 0, 9, 0, 0 },
              { 0, 0, 0, 0 },
              { 0, 9, 0, 0 },
            };
   static const char Plus_Tetrad [TETRAD_PIC_WIDTH][TETRAD_PIC_WIDTH] =
            {
              { 0, 0, 0, 0,},
              { 0, 10, 0, 0 },
              { 10, 0, 10, 0 },
              { 0, 0, 0, 0 },
            };
   static const char Angle90_Tetrad [TETRAD_PIC_WIDTH][TETRAD_PIC_WIDTH] =
            {
              { 0, 0, 0, 0,},
              { 0, 0, 0, 0 },
              { 1, 0, 0, 0 },
              { 0, 1, 1, 0 },
            };
    static const char Arrow_Tetrad [TETRAD_PIC_WIDTH][TETRAD_PIC_WIDTH] =
            {
              { 0, 0, 0, 0,},
              { 0, 0, 0, 0 },
              { 0, 2, 0, 0 },
              { 0, 0, 0, 0 },
            };


//00000000000000000000000000000000000000000000000000000000000000000000000
/*

 struct BlockPic
   {
       char Data[TETRAD_PIC_WIDTH][TETRAD_PIC_WIDTH];
   };

*/
//00000000000000000000000000000000000000000000000000000000000000000000000

 void InitializeBlockPic ( struct BlockPic MyBlockPic
                              [][TETRAD_MAX_ROTATIONS] );

 void Rotate_Block ( struct BlockPic *MyBlockPic, short RotationIndex,
                    short BlockType );

 void Rotate_3x3 ( char* SourceBlock, char* TrashBlock, short Xdisplace,
                  short Ydisplace, short BlockWidth, short BlockHeight,
                  char EmptyColor );

 void Copy_Block ( char *DestBlock, char *SourceBlock, const short Width,
                   const short Height );

 void Rotate_4x1 ( char *SourceBlock, short RotationIndex );

  void Replace_Block_Zeros ( char *BlockPtr, char ReplaceColor,
                            const short Width, const short Height );

 void DebugDisplayAllTetrads ( struct BlockPic Tetrads[][TETRAD_MAX_ROTATIONS] );

//00000000000000000000000000000000000000000000000000000000000000000000000

 void Rotate_Block ( struct BlockPic *MyBlockPic, short RotationIndex,
                    short BlockType )
   {
      char *BlockPicturePtr;
      short  RotationCounter;
      short  Xdisplace, Ydisplace;
      char DummyBlock[TETRAD_PIC_HEIGHT][TETRAD_PIC_WIDTH];

      switch (BlockType)
        {
          case BLOCK_L_TETRAD: BlockPicturePtr = (char*)(L_Tetrad);
                               Xdisplace = 0;
                               Ydisplace = 1;
                               break;
          case BLOCK_T_TETRAD: BlockPicturePtr = (char*)(T_Tetrad);
                               Xdisplace = 0;
                               Ydisplace = 1;
                               break;
          case BLOCK_LONG_TETRAD: BlockPicturePtr = (char*)(Long_Tetrad_1);
                                  Xdisplace = 0;
                                  Ydisplace = 0;
                                  break;
          case BLOCK_SQUARE_TETRAD: BlockPicturePtr = (char*)(Square_Tetrad);
                                    Xdisplace = 0;
                                    Ydisplace = 0;
                                    break;
          case BLOCK_Z_TETRAD_1: BlockPicturePtr = (char*)(Z_Tetrad_1);
                                 Xdisplace = 0;
                                 Ydisplace = 1;
                                 break;
          case BLOCK_Z_TETRAD_2: BlockPicturePtr = (char*)(Z_Tetrad_2);
                                 Xdisplace = 0;
                                 Ydisplace = 1;
                                 break;

          // unconventional shapes

          case BLOCK_SHORT_TETRAD:
                                 BlockPicturePtr = (char*)(Short_Tetrad);
                                 Xdisplace = 0;
                                 Ydisplace = 1;
                                 break;
          case BLOCK_SHORT_L_TETRAD:
                                 BlockPicturePtr = (char*)(Short_L_Tetrad);
                                 Xdisplace = 0;
                                 Ydisplace = 1;
                                 break;
          case BLOCK_C_TETRAD:
                                 BlockPicturePtr = (char*)(C_Tetrad);
                                 Xdisplace = 0;
                                 Ydisplace = 1;
                                 break;
          case BLOCK_PLUS_TETRAD:
                                 BlockPicturePtr = (char*)(Plus_Tetrad);
                                 Xdisplace = 0;
                                 Ydisplace = 1;
                                 break;
          case BLOCK_ANGLE90_TETRAD:
                                 BlockPicturePtr = (char*)(Angle90_Tetrad);
                                 Xdisplace = 0;
                                 Ydisplace = 1;
                                 break;
          case BLOCK_ARROW_TETRAD:
                                 BlockPicturePtr = (char*)(Arrow_Tetrad);
                                 Xdisplace = 0;
                                 Ydisplace = 1;
                                 break;
          default:
                    break;
        }

   Copy_Block ( (char *)MyBlockPic->Data, BlockPicturePtr,
                TETRAD_PIC_WIDTH, TETRAD_PIC_HEIGHT );

   if ( BlockType != BLOCK_SQUARE_TETRAD &&
        BlockType != BLOCK_LONG_TETRAD )
      for ( RotationCounter = 0; RotationCounter <= RotationIndex;
            RotationCounter++ )
         Rotate_3x3 ( (char *)MyBlockPic->Data, (char *)DummyBlock,
                      Xdisplace, Ydisplace, TETRAD_PIC_WIDTH,
                      TETRAD_PIC_HEIGHT, EMPTY_CELL_COLOR );
   else
   if ( BlockType == BLOCK_LONG_TETRAD )
        Rotate_4x1 ( (char *)MyBlockPic->Data, RotationIndex );
   else
        ; // null statement

   Replace_Block_Zeros ( (char *)MyBlockPic->Data, EMPTY_CELL_COLOR,
                         TETRAD_PIC_WIDTH, TETRAD_PIC_HEIGHT );

   }

//00000000000000000000000000000000000000000000000000000000000000000000000

 void Rotate_3x3 ( char* SourceBlock, char* TrashBlock, short Xdisplace,
                  short Ydisplace, short BlockWidth, short BlockHeight,
                  char EmptyColor )
{
    static short PreRotation_3x3 [9][2] =
       {
           { 0, 0 }, { 1, 0 }, { 2, 0 },
           { 0, 1 }, { 1, 1 }, { 2, 1 },
           { 0, 2 }, { 1, 2 }, { 2, 2 }
       };

    static short PostRotation_3x3 [9][2] =
       {
           { 0, 2 }, { 0, 1 }, { 0, 0 },
           { 1, 2 }, { 1, 1 }, { 1, 0 },
           { 2, 2 }, { 2, 1 }, { 2, 0 }
       };

    short x1, y1, x2, y2;
    short Index;

    for ( y1 = 0; y1 < BlockHeight; y1++ )
       for ( x1 = 0; x1 < BlockWidth; x1++ )
            *( TrashBlock + x1 + y1 * BlockWidth) = EmptyColor;

    for ( Index = 0; Index < 9; Index++ )
        {
          x1 = PreRotation_3x3[Index][0] + Xdisplace;
          y1 = PreRotation_3x3[Index][1] + Ydisplace;

          x2 = PostRotation_3x3[Index][0] + Xdisplace;
          y2 = PostRotation_3x3[Index][1] + Ydisplace;


          *( TrashBlock + x2 + y2 * BlockWidth ) =
            *( SourceBlock + x1 + y1 * BlockWidth );

        }

    for ( y1 = 0; y1 < BlockHeight; y1++ )
       for ( x1 = 0; x1 < BlockWidth; x1++ )
          *( SourceBlock + x1 + y1 * BlockWidth ) =
            *( TrashBlock + x1 + y1 * BlockWidth );

}

//00000000000000000000000000000000000000000000000000000000000000000000000

 void InitializeBlockPic ( struct BlockPic
                                   MyBlockPic[][TETRAD_MAX_ROTATIONS] )
   {
      short BlockTypeIndex;
      short BlockRotationIndex;

      for ( BlockTypeIndex = 0; BlockTypeIndex < TETRAD_TYPE_COUNT;
            BlockTypeIndex++ )
          {
             for ( BlockRotationIndex = 0;
                   BlockRotationIndex < TETRAD_MAX_ROTATIONS;
                   BlockRotationIndex++ )
                 {
                   Rotate_Block ( &MyBlockPic[BlockTypeIndex]
                                            [BlockRotationIndex],
                                  BlockRotationIndex, BlockTypeIndex );
                 }
          }
   }

//00000000000000000000000000000000000000000000000000000000000000000000000

 void Copy_Block ( char *DestBlock, char *SourceBlock, const short Width,
                   const short Height )
   {
       short x, y;

     for ( y = 0; y < Height; y++ )
       for ( x = 0; x < Width; x++ )
          *( DestBlock + x + y * Width ) = *( SourceBlock + x + y * Width );
   }

//00000000000000000000000000000000000000000000000000000000000000000000000

  void Rotate_4x1 ( char *SourceBlock, short RotationIndex )
   {
       if ( RotationIndex == 0 || RotationIndex == 2 )

            Copy_Block ( SourceBlock, (char *)Long_Tetrad_2,
                 TETRAD_PIC_WIDTH, TETRAD_PIC_HEIGHT );
       else
       if ( RotationIndex == 1 || RotationIndex == 3 )

             Copy_Block ( SourceBlock, (char *)Long_Tetrad_1,
                 TETRAD_PIC_WIDTH, TETRAD_PIC_HEIGHT );

       else
             ; // null statement
   }

//00000000000000000000000000000000000000000000000000000000000000000000000

 void Replace_Block_Zeros ( char *BlockPtr, char ReplaceColor,
                            const short Width, const short Height )
  {
      short Xindex, Yindex;

      for ( Yindex = 0; Yindex < Height; Yindex++ )
         for ( Xindex = 0; Xindex < Width; Xindex++ )

            if ( *(BlockPtr + Xindex + Yindex * Width ) == 0 )
                 *(BlockPtr + Xindex + Yindex * Height ) = ReplaceColor;

  }

//00000000000000000000000000000000000000000000000000000000000000000000000

void DebugDisplayAllTetrads ( struct BlockPic Tetrads[][TETRAD_MAX_ROTATIONS] )
{

/*
   for ( short y = 0; y < TETRAD_TYPE_COUNT; y++ )
     {
           clrscr();

       for ( short x = 0; x < TETRAD_MAX_ROTATIONS; x++ )
           {
              for ( short row = 0; row < 4; row++ )
               {
                 for ( short col = 0; col < 4; col++ )
                       cout << Tetrads[y][x].Data[row][col];
                 cout << endl;
               }
                 cout << endl << endl;

            }
            getch();
     }
*/
}

//00000000000000000000000000000000000000000000000000000000000000000000000

/*

void main ()
{
   BlockPic Tetrads[TETRAD_TYPE_COUNT][TETRAD_MAX_ROTATIONS];

   InitializeBlockPic( Tetrads );

   DebugDisplayAllTetrads ( Tetrads );


}

*/




