

/*
#include "D:\TIGCC\Projects\Blocks\globals.h"
#include "D:\TIGCC\Projects\Blocks\glob_var.h"
#include "D:\TIGCC\Projects\Blocks\gameio.c"
*/


#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\globals.h"
#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\glob_var.h"
#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\gameio.c"


#include <gray.h>
#include <stdlib.h>

// #define MAX_CLEAR_ROWS    5

/*
struct ClearRowsList
{
       short Rows[MAX_CLEAR_ROWS];
       short RowClearCount;
};

*/

//00000000000000000000000000000000000000000000000000000000000000000000000


void ClearFilledRows ( struct PlayField*  MyPlayField,
                       struct ClearRowsList* MyClearRowsList );

void MainClearRows ( struct PlayField* MyPlayField,
                     short GravityDirection );

void ShiftBlocksDown ( struct PlayField* MyPlayField,
                       struct ClearRowsList* MyClearRowsList,
                       short GravityDirection );

void AnimateClearRows ( struct PlayField* MyPlayField,
                        struct ClearRowsList* MyClearRowsList );


//00000000000000000000000000000000000000000000000000000000000000000000000


void ClearFilledRows ( struct PlayField*  MyPlayField,
                       struct ClearRowsList* MyClearRowsList )
{
    short InterWallWidth;
    short CellCounter;
    short ColumnIndex;
    short ClearColumnIndex;
    short RowIndex;
    short RowsClearedFlag;

   RowsClearedFlag = false;

   MyClearRowsList->RowClearCount = 0;

  InterWallWidth = MyPlayField->RightBoundary -
                   MyPlayField->LeftBoundary - 1;

  for ( RowIndex = 0; RowIndex < PLAYFIELD_HEIGHT; RowIndex++ )
      {
        CellCounter = 0;

        for ( ColumnIndex = MyPlayField->LeftBoundary + 1;
              ColumnIndex < MyPlayField->RightBoundary;
              ColumnIndex++ )
           if ( MyPlayField->Field[RowIndex][ColumnIndex] !=
                EMPTY_CELL_COLOR )
                CellCounter++;

        if ( CellCounter >= InterWallWidth )
           {
             for ( ClearColumnIndex = MyPlayField->LeftBoundary + 1;
                   ClearColumnIndex < MyPlayField->RightBoundary;
                   ClearColumnIndex++ )
                MyPlayField->Field[RowIndex][ClearColumnIndex] =
                       EMPTY_CELL_COLOR;

                MyClearRowsList->Rows[
                    MyClearRowsList->RowClearCount ] = RowIndex;

                MyClearRowsList->RowClearCount++;
           }
      }

}

//00000000000000000000000000000000000000000000000000000000000000000000000

void MainClearRows ( struct PlayField* MyPlayField,
                     short GravityDirection )
{
   struct ClearRowsList MyClearRowsList;

   ClearFilledRows ( MyPlayField, &MyClearRowsList );
   
   MyPlayField->RowClearCount = MyClearRowsList.RowClearCount;

 if ( MyClearRowsList.RowClearCount > 0 )
    {
      AnimateClearRows ( MyPlayField, &MyClearRowsList );

      ShiftBlocksDown ( MyPlayField, &MyClearRowsList, GravityDirection );
    }
    
}

//00000000000000000000000000000000000000000000000000000000000000000000000

void ShiftBlocksDown ( struct PlayField* MyPlayField,
                       struct ClearRowsList* MyClearRowsList,
                       short GravityDirection )
{
    char TempPlayField[ PLAYFIELD_HEIGHT ][ PLAYFIELD_WIDTH ];

    short RowIndex, ColumnIndex, CellCounter;
    short InterWallWidth;
    short ClearRowIndex;

    InterWallWidth = MyPlayField->RightBoundary -
                     MyPlayField->LeftBoundary - 1;


    if ( GravityDirection > 0 )
       {
         ClearRowIndex = PLAYFIELD_HEIGHT - 1;

          for ( RowIndex = PLAYFIELD_HEIGHT - 1;
                RowIndex >= 0;
                RowIndex-- )
          {
             CellCounter = 0;

             for ( ColumnIndex = MyPlayField->LeftBoundary + 1;
                   ColumnIndex < MyPlayField->RightBoundary;
                   ColumnIndex++ )
                 {
                    TempPlayField[RowIndex][ColumnIndex] = EMPTY_CELL_COLOR;

                    if ( MyPlayField->Field[RowIndex][ColumnIndex] ==
                         EMPTY_CELL_COLOR )
                         CellCounter++;
                 }

                if ( CellCounter < InterWallWidth )
                   {
                     for ( ColumnIndex = MyPlayField->LeftBoundary + 1;
                           ColumnIndex < MyPlayField->RightBoundary;
                           ColumnIndex++ )
                           TempPlayField[ClearRowIndex][ColumnIndex] =
                           MyPlayField->Field[RowIndex][ColumnIndex];

                      ClearRowIndex--;
                   }
          }

          for ( RowIndex = PLAYFIELD_HEIGHT - 1;
                RowIndex >= 0;
                RowIndex-- )
          for ( ColumnIndex = MyPlayField->LeftBoundary + 1;
                ColumnIndex < MyPlayField->RightBoundary;
                ColumnIndex++ )
          MyPlayField->Field[RowIndex][ColumnIndex] =
          TempPlayField[RowIndex][ColumnIndex];

       }
    else
    if ( GravityDirection < 0 )
       {
         ClearRowIndex = 0;

          for ( RowIndex = 0;
                RowIndex < PLAYFIELD_HEIGHT;
                RowIndex++ )
          {
             CellCounter = 0;

             for ( ColumnIndex = MyPlayField->LeftBoundary + 1;
                   ColumnIndex < MyPlayField->RightBoundary;
                   ColumnIndex++ )
                 {
                    TempPlayField[RowIndex][ColumnIndex] = EMPTY_CELL_COLOR;

                    if ( MyPlayField->Field[RowIndex][ColumnIndex] ==
                         EMPTY_CELL_COLOR )
                         CellCounter++;
                 }

                if ( CellCounter < InterWallWidth )
                   {
                     for ( ColumnIndex = MyPlayField->LeftBoundary + 1;
                           ColumnIndex < MyPlayField->RightBoundary;
                           ColumnIndex++ )
                           TempPlayField[ClearRowIndex][ColumnIndex] =
                           MyPlayField->Field[RowIndex][ColumnIndex];

                      ClearRowIndex++;
                   }
          }

          for ( RowIndex = 0;
                RowIndex < PLAYFIELD_HEIGHT;
                RowIndex++ )
          for ( ColumnIndex = MyPlayField->LeftBoundary + 1;
                ColumnIndex < MyPlayField->RightBoundary;
                ColumnIndex++ )
          MyPlayField->Field[RowIndex][ColumnIndex] =
          TempPlayField[RowIndex][ColumnIndex];
       }

}

//00000000000000000000000000000000000000000000000000000000000000000000000


void AnimateClearRows ( struct PlayField* MyPlayField,
                        struct ClearRowsList* MyClearRowsList )
{
     short StartColumn, EndColumn;
     short ColumnIndex, RowIndex;
     short ClearRowIndex;
     short RowClearIndex;;
     short AnimationIndex;
     short DelayLoopIndex;
     short JerkX;
     short JerkY;
     
    void *ActiveLightLayer;
    void *ActiveDarkLayer;
    
    ActiveLightLayer = GrayDBufGetActivePlane ( LIGHT_PLANE );
    ActiveDarkLayer = GrayDBufGetActivePlane ( DARK_PLANE ); 

     StartColumn = MyPlayField->LeftBoundary + 1;
     EndColumn = MyPlayField->RightBoundary - 1;

 for ( AnimationIndex = 0; AnimationIndex < 5; AnimationIndex++ )
   {
   	
    for ( DelayLoopIndex = 0; DelayLoopIndex < 10; DelayLoopIndex++ )
    {
    	
     RowClearIndex = 0;

     while ( RowClearIndex < MyClearRowsList->RowClearCount )
       {
           for ( ColumnIndex = StartColumn;
                 ColumnIndex <= EndColumn;
                 ColumnIndex++ )
           {
                /* Special effects */
                
                 JerkX = ColumnIndex;
                 JerkY = MyClearRowsList->Rows[RowClearIndex];
                 
                 if ( gExplosion )
                    {
                      JerkX += random(7) - 3;
                      JerkY += random(7) - 3;
                      
                      if ( JerkX < 0 )
                           JerkX = 0;
                      else
                      if ( JerkX > PLAYFIELD_WIDTH - 1 )
                           JerkX = PLAYFIELD_WIDTH - 1;
                           
                      if ( JerkY < 0 )
                           JerkY = 0;
                      else
                      if ( JerkY > PLAYFIELD_HEIGHT - 1 )
                           JerkY = PLAYFIELD_HEIGHT - 1;
                    }
                                      
                 DrawCell_XOR_Special ( JerkX, 
                               JerkY,
                               1,
                               ActiveLightLayer,
                               ActiveDarkLayer );
           }
           
           RowClearIndex++;
       }
    }
       
       //CopyBuffer();
       //delay(50);

   for ( DelayLoopIndex = 0; DelayLoopIndex < 10; DelayLoopIndex++ )
    {
    	
     RowClearIndex = 0;

     while ( RowClearIndex < MyClearRowsList->RowClearCount )
       {
           for ( ColumnIndex = StartColumn;
                 ColumnIndex <= EndColumn;
                 ColumnIndex++ )
           {
                /* Special effects */
                
                 JerkX = ColumnIndex;
                 JerkY = MyClearRowsList->Rows[RowClearIndex];
                 
                 if ( gExplosion )
                    {
                      JerkX += random(20) - 10;
                      JerkY += random(20) - 10;
                      
                      if ( JerkX < 0 )
                           JerkX = 0;
                      else
                      if ( JerkX > PLAYFIELD_WIDTH - 1 )
                           JerkX = PLAYFIELD_WIDTH - 1;
                           
                      if ( JerkY < 0 )
                           JerkY = 0;
                      else
                      if ( JerkY > PLAYFIELD_HEIGHT - 1 )
                           JerkY = PLAYFIELD_HEIGHT - 1;
                    }
                               
                 DrawCell_XOR_Special ( JerkX, 
                                JerkY,
                                1,
                                ActiveLightLayer,
                                ActiveDarkLayer );
           }
            
           RowClearIndex++;
       }
       
     }
       //CopyBuffer();
       //delay(50);
   }
}

//00000000000000000000000000000000000000000000000000000000000000000000000