
#ifndef LINK_C_DEFINED
 
   #define LINK_C_DEFINED

//0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0

//#include "D:\TIGCC\Projects\Blocks\glob_var.h"

#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\glob_var.h"

#include <string.h>
#include <link.h>
#include <kbd.h>
#include <compat.h>
#include <stdio.h>
#include <stdlib.h>
#include <graph.h>

//0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0

#define LINK_START "INI"
#define LINK_L1    "1"
#define LINK_L2    "2"
#define LINK_L3    "3"
#define LINK_L4    "4"
#define LINK_OL    "L"   // opponent defeated

#define LINK_BUFFER_SIZE                   50
#define LINK_STRING_LENGTH                 12
#define LINK_IN_GAME_COMMAND_STRING_LENGTH  1

#define LINK_NO_COMMAND    -1

#define UNSIGNED_INT_MAX_VALUE 0xFFFFU

//0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0

enum LinkConstants 
     {
        CONST_LINK_START,
        CONST_LINK_L1,
        CONST_LINK_L2,
        CONST_LINK_L3,
        CONST_LINK_L4,
        CONST_LINK_OL 
     };
     
//0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0

static char LinkCommandList [][LINK_STRING_LENGTH] = 
       {
         LINK_START,
         LINK_L1,  
         LINK_L2,   
         LINK_L3,   
         LINK_L4,   
         LINK_OL          
       };

//0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0       

struct DoubleChar
{
     char Byte1;
     char Byte2;
};

//0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0

union IntDoubleChar
{
      unsigned short Integer;
      
      struct DoubleChar Bytes;
};

//0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0

struct LinkVariables
{
    short  SendCommand;
    unsigned short SendCounter;
    short RecieveCommand;
    unsigned short RecieveCounter;
};

//0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0

InitializeLink ();

VisibleInitializeLink ();

void InitializeLinkVariables ( struct LinkVariables* LKV );

void LinkSend ( const short Command, unsigned int* SendCounter );

short LinkRecieve ( unsigned int* RecieveCounter );

inline void CloseLink();

/*
short TugAWarSendData ( char* SendBuffer, char* RecieveBuffer,
                       const short BufferSize );
*/

short GrandLink ( short Command, 
         
     struct LinkVariables *MyLinkVariables,
     struct PlayField     *MyPlayField,
     struct GameOptions   *MyGameOptions,
     struct DroppingBlock *MyDroppingBlock );
     
void AddRowsPlayField ( struct PlayField *MyPlayField, 
                        short RowCount,
                        short GravityDirection );


//0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0
/*
    // Suggested usage

    short  Command;
    unsigned short SendCounter;
    short RecCommand;
    unsigned short RecCounter;

    Command = LINK_NO_COMMAND;
    RecCounter = UNSIGNED_INT_MAX_VALUE;

    Display "Connecting..."
    
    InitializeLink()
    
    while(1)
     {
        ...
        
       if ( condition1 )
          {
            Command = CONSTANT1;
            SendCounter = 0;
          }
       if ( condition2 )
          {
            Command = CONSTANT2;
            SendCounter = 0;
          }
     
       LinkSend ( Command, &SendCounter );               
       
       RecCommand = LinkRecieve ( &RecCounter );
       
       if ( RecCommand == CONSTANT_1 )
          {
            ...
          }
        
        ...
     }

*/
//0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0

InitializeLink ()
{
    static char RecieveBuffer[LINK_BUFFER_SIZE] = {0};
    short  SuccessFlag;
    short i;
    
    SuccessFlag = 1;

    memset ( RecieveBuffer, 0, LINK_BUFFER_SIZE );    
    
    OSLinkOpen (); 
    
    while(1)
     {
       LIO_SendData ( LINK_START, strlen(LINK_START));

       LIO_RecvData ( RecieveBuffer, LINK_BUFFER_SIZE - 1, 1 ); 
 
       if ( strstr( RecieveBuffer, LINK_START ))
            break;       

       if ( _keytest( RR_CLEAR ) )
          {
             SuccessFlag = 0;
             break;
          }
      }  
  
    return SuccessFlag;       
}

//0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0

VisibleInitializeLink ()
{
    short ReturnValue;
    
    clrscr();
    
    FontSetSys ( F_6x8 );
    
    printf("Connecting...\n\n");
    
    if ( ReturnValue = InitializeLink() )
         printf("Link established...\n\n");
    else
         printf("Connection failure!\n\n");

    return ReturnValue;
}

//0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0

void InitializeLinkVariables ( struct LinkVariables* LKV )
{
  
   LKV->SendCommand = LINK_NO_COMMAND;
   LKV->SendCounter = 0;
   LKV->RecieveCommand = LINK_NO_COMMAND;
   LKV->RecieveCounter = UNSIGNED_INT_MAX_VALUE;
}

//0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0

void LinkSend ( const short Command, unsigned int* SendCounter )
{
     static char SendBuffer [ LINK_BUFFER_SIZE ] = {0};
     
     static union IntDoubleChar MyIntDoubleChar = {0, 0, 0 };
     
     MyIntDoubleChar.Integer = *SendCounter;
     
    strcpy ( SendBuffer, LinkCommandList[Command] );  
  
    SendBuffer[LINK_IN_GAME_COMMAND_STRING_LENGTH] =
        MyIntDoubleChar.Bytes.Byte1;
    
    SendBuffer[LINK_IN_GAME_COMMAND_STRING_LENGTH + 1] = 
        MyIntDoubleChar.Bytes.Byte2;
    
    SendBuffer[LINK_IN_GAME_COMMAND_STRING_LENGTH + 2] = NULL;             
            
     LIO_SendData ( SendBuffer,  
             LINK_IN_GAME_COMMAND_STRING_LENGTH + 2 );

     if ( *SendCounter < UNSIGNED_INT_MAX_VALUE )
         (*SendCounter)++;
}

//0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0

short LinkRecieve ( unsigned int* RecieveCounter )
{
     static char RecieveBuffer [ LINK_BUFFER_SIZE ] = {0};
     static short Command = -1;
     static char* StrPtr;
     
     Command = LINK_NO_COMMAND;
        
     LIO_RecvData ( RecieveBuffer, LINK_BUFFER_SIZE - 1, 1 ); 
     

     if ( StrPtr = strstr( RecieveBuffer, LINK_L1 ))
          Command = CONST_LINK_L1;

     else
     if ( StrPtr = strstr( RecieveBuffer, LINK_L2 ))
          Command = CONST_LINK_L2;

     else
     if ( StrPtr = strstr( RecieveBuffer, LINK_L3 ))
          Command = CONST_LINK_L3;

     else
     if ( StrPtr = strstr( RecieveBuffer, LINK_L4 ))
          Command = CONST_LINK_L4;

     else
     if ( StrPtr = strstr( RecieveBuffer, LINK_OL ))
          Command = CONST_LINK_OL;
      
     else
        ; // null statement

     if ( StrPtr != NULL )
        {
          StrPtr += LINK_IN_GAME_COMMAND_STRING_LENGTH;
          
          // ignore repetitions of the same command
          // after it is already recieved
          
          if ( *(unsigned int*)StrPtr > *RecieveCounter )
                Command = LINK_NO_COMMAND;   
          else
               *RecieveCounter = *(unsigned int*)StrPtr;
                
          memset ( RecieveBuffer, 0, LINK_BUFFER_SIZE );
        }

     return Command;
}

//0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0

void CloseLink()
{
     OSLinkClose ();
}

//0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0

/*

short TugAWarSendData ( char* SendBuffer, char* RecieveBuffer,
                       const short BufferSize )
{
    enum LocalConstants { MESSAGE_LENGTH = 4,
                          MAX_LOOPS      = 1000 };
    
    static unsigned char Message1[] = "RAND";
    static unsigned char Message2[] = "#END";
    static unsigned char Message3[] = "#REC";
    static unsigned char RandomBuffer[] = "0000 ";

    unsigned char RandomChar;
    unsigned char RecievedRandomChar;

    unsigned char *StrPtr;
    
    short SendSuccessFlag;
    short Index;
    
    SendSuccessFlag = 0;
  
    memset ( RecieveBuffer, 0, BufferSize );
 
    strcpy ( RandomBuffer, Message1 );
 
    RandomBuffer[MESSAGE_LENGTH + 1 ] = NULL;
  
   // debug
   printf("Phase 1\n");
   
 for ( Index = 0; Index< MAX_LOOPS; Index++ )
  {
      RandomChar = (unsigned char)random(256);
 
      RandomBuffer[MESSAGE_LENGTH] = RandomChar;

    while(1)
     { 
       LIO_SendData ( Message1, MESSAGE_LENGTH + 1 );

       LIO_RecvData ( RecieveBuffer, LINK_BUFFER_SIZE, 1 ); 
 
       if ( StrPtr = strstr( RecieveBuffer, Message1 ))
            break;
      }  
      
      RecievedRandomChar = *(StrPtr + MESSAGE_LENGTH );
      
      if ( RandomChar == RecievedRandomChar )
           ; // mull statement
      else
           break;
  }        
     
  if ( RandomChar > RecievedRandomChar )
     {
        // debug
        printf("Phase 2A\n");     
     
        *(SendBuffer + BufferSize )    = Message2[0];
        *(SendBuffer + BufferSize + 1) = Message2[1];
        *(SendBuffer + BufferSize + 2) = Message2[2];
        *(SendBuffer + BufferSize + 3) = Message2[3];

    for ( Index = 0; Index< MAX_LOOPS; Index++ )
        {
           LIO_SendData ( SendBuffer, BufferSize + MESSAGE_LENGTH );
    
           LIO_RecvData ( RecieveBuffer, BufferSize, 1 ); 
 
          if ( StrPtr = strstr( RecieveBuffer, Message3 ))
               break;
        }
        
        SendSuccessFlag = 1;
     }
  else
     {
       // debug
       printf("Phase 2B\n");
     
       for ( Index = 0; Index< MAX_LOOPS; Index++ )
           {
              LIO_RecvData ( RecieveBuffer, LINK_BUFFER_SIZE, 1 ); 
 
              if ( StrPtr = strstr( RecieveBuffer, Message2 ))
                   break;
           }
       for ( Index = 0; Index< MAX_LOOPS; Index++ ) 
          LIO_SendData ( Message3, MESSAGE_LENGTH );
    
     }
      
     return SendSuccessFlag;
}
*/

//0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0

short GrandLink ( short Command, 
         
     struct LinkVariables *MyLinkVariables,
     struct PlayField     *MyPlayField,
     struct GameOptions   *MyGameOptions,
     struct DroppingBlock *MyDroppingBlock )
{
   short ReturnValue;
    
   static short LocalConstants[] = 
      { 
        0,
        CONST_LINK_L1,
        CONST_LINK_L2,
        CONST_LINK_L3,
        CONST_LINK_L4,
        CONST_LINK_OL 
      };
   
    if ( Command == 0 )
       {
         ReturnValue = VisibleInitializeLink();
         InitializeLinkVariables ( MyLinkVariables );
       }
    else
    if ( Command == 1 )
       {
       
         if ( MyPlayField->RowClearCount > 0 )
              MyLinkVariables->SendCommand
              = LocalConstants[ MyPlayField->RowClearCount ];
               
         // if ( MyPlayField->GameOverFlag )
         //      MyLinkVariables->SendCommand = LocalConstants[5];
         
         LinkSend ( MyLinkVariables->SendCommand, 
                   &MyLinkVariables->SendCounter );
              
         MyLinkVariables->RecieveCommand = 
             LinkRecieve ( &MyLinkVariables->RecieveCounter );
       
        if ( MyLinkVariables->RecieveCommand != LINK_NO_COMMAND )      
         switch ( MyLinkVariables->RecieveCommand )
            {
              case CONST_LINK_L1: 
                   
                   AddRowsPlayField ( MyPlayField, 1,
                      MyDroppingBlock->GravityDirection );
                      break;
                      
              case CONST_LINK_L2:
              
                   AddRowsPlayField ( MyPlayField, 2,
                      MyDroppingBlock->GravityDirection );
                      break;
                                    
              case CONST_LINK_L3:
              
                   AddRowsPlayField ( MyPlayField, 3,
                      MyDroppingBlock->GravityDirection );
                      break;
                                    
              case CONST_LINK_L4:
              
                   AddRowsPlayField ( MyPlayField, 4,
                      MyDroppingBlock->GravityDirection );
                      break;
                                    
              case CONST_LINK_OL:
              default:
                       break;                 
            }

       }
    else
    if ( Command == 3 )
       {
         CloseLink ();
       }
       
    return ReturnValue;
}

//0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0

void AddRowsPlayField ( struct PlayField *MyPlayField, 
                        short RowCount,
                        short GravityDirection )
{
    short x, y, Xstart, Xend, Ystart, Yend, RowClearCount;
    short CopyX, CopyY, CopyYstart, CopyYend;
    
    char Field [FIELD_ARRAY_HEIGHT][FIELD_ARRAY_WIDTH];
    
    Xstart = PLAYFIELD_WALL_1_X + 1;
    Xend   = PLAYFIELD_WALL_2_X - 1;
    
    RowClearCount = RowCount;
    
    for ( y = 0; y < FIELD_ARRAY_HEIGHT; y++ )
      for ( x = Xstart; x <= Xend; x++ )
            Field[y][x] = MyPlayField->Field[y][x];
     
    //-------------------------------------------------------         
    //-------------------------------------------------------        
     
    if ( GravityDirection > 0 )
       {
         Ystart = FIELD_ARRAY_HEIGHT - RowClearCount;
         Yend   = FIELD_ARRAY_HEIGHT - 1;

         for ( y = Ystart; y <= Yend; y++ )
             {
                for ( x = Xstart; x <= Xend; x++ )         
                      MyPlayField->Field[y][x] = 1;    
                 
                MyPlayField->Field[y][ random(Xend - Xstart + 1) + Xstart ] 
                     = EMPTY_CELL_COLOR;
             }
             
         CopyYstart = RowClearCount - 1;
         CopyYend = FIELD_ARRAY_HEIGHT - 1;        
             Ystart = 0;
             Yend = FIELD_ARRAY_HEIGHT - RowClearCount - 1;
         
         CopyY = CopyYstart;
         
         for ( y = Ystart; y <= Yend; y++, CopyY++ )
            for ( x = CopyX = Xstart; x <= Xend; x++, CopyX++ )
                {
                  MyPlayField->Field[y][x] = Field[CopyY][CopyX]; 
                }
       }
       
    //-------------------------------------------------------    
    //------------------------------------------------------- 
       
    else
    if ( GravityDirection < 0 )
       {
       }
}

//0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0=0

/*

void _main()
{
    char SendBuffer[LINK_BUFFER_SIZE] = "";
    char RecBuffer[LINK_BUFFER_SIZE]  = "";
    
    clrscr();
    
    if ( InitializeLink() )
         printf("Connected!\n");
    else
         printf("Connection Failure!\n");
      
            
    strcpy ( SendBuffer, "RAINING" );
    
    { short x, b;
           
     b = TugAWarSendData ( SendBuffer, RecBuffer, 8 );
    
    
    
       if ( b )
           printf("Sender\n\n");
       else
         printf("Receiver\n\n");
         
       for ( x = 0; x < 10; x++ )
             putchar ( RecBuffer[x] );
       printf("\n");
    }
    
    while (1)
      if ( _keytest( RR_CLEAR ))
           break;       
}

*/


#endif
