// C Source File
// Created 12/24/04; 10:32:14 PM

#ifndef SCORES_C_DEFINED

     #define SCORES_C_DEFINED
     
//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8 
     
#define HIGH_SCORE_NAME_LENGTH   10

#define HIGH_SCORES_PER_PAGE     8

#define COMPARE_HIGH_SCORES_RETURN_NEGATIVE -1


//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8 

#include <string.h>
#include <graph.h>
#include <stdio.h>

/*
#include "D:\TIGCC\Projects\Blocks\Menu.c"
#include "D:\TIGCC\Projects\Blocks\glob_var.h"
#include "D:\TIGCC\Projects\Blocks\Gets.c"
*/

#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\glob_var.h"
#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\Menu.c"
#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\Gets.c"


//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8 
 
struct HighScores
{
    char Name [HIGH_SCORE_NAME_LENGTH];
    
    short  High;
    short  PlayerCount;
    short  Speed;
    short  AutoSpeedFlag;
    long Score;
    
};

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8     

void InitializeHighScores ( struct HighScores* MasterList,
                            short MasterListCount );

CompareHighScores ( struct HighScores* MasterList,
                    struct HighScores* MyScore,
                    short MasterListCount ); 
                    
void InsertMyScore ( struct HighScores* MasterList,
                     const struct HighScores* MyScore,
                     const short MasterListCount,
                     const short InsertionIndex ); 
                    
void DisplayHighScores ( struct HighScores* MasterList,
                         const short MasterListCount );

void DoHighScores ( struct HighScores* MasterList,
                    const short MasterListCount,
                    const struct GameOptions* MyGameOptions,
                    const struct PlayField* MyPlayField );                     
                      
                    
//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8                   

void InitializeHighScores ( struct HighScores* MasterList,
                       short MasterListCount )
{
   short Index;
   
   for ( Index = 0; Index < MasterListCount; Index++ )
       {
          strcpy ( (*(MasterList + Index)).Name, 
                      "Nameless" );
          
          (*(MasterList + Index)).Score = 0;
          (*(MasterList + Index)).High = 0;
          (*(MasterList + Index)).Speed = 0;
          (*(MasterList + Index)).AutoSpeedFlag = 0;          
       }        
}

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8       
     
CompareHighScores ( struct HighScores* MasterList,
                    struct HighScores* MyScore,
                    short MasterListCount )
                    
{
  short Index, ScoreReplaceIndex;
   
  ScoreReplaceIndex = COMPARE_HIGH_SCORES_RETURN_NEGATIVE; 
    
  for ( Index = 0; Index < MasterListCount; Index++ )
      {
         if (  (*MyScore).Score > 
               (*( MasterList + Index )).Score )
            {
                ScoreReplaceIndex = Index;
                break;
            }
             
      }     
  
  return ScoreReplaceIndex;
}     

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8     

void InsertMyScore ( struct HighScores* MasterList,
                     const struct HighScores* MyScore,
                     const short MasterListCount,
                     const short InsertionIndex )
{
   struct HighScores HighScoreBackUp_1;
   struct HighScores HighScoreBackUp_2;
   
   short Index;


   HighScoreBackUp_1 = (*(MasterList + InsertionIndex ));
   
   (*(MasterList + InsertionIndex )) = *MyScore;
   
   
  for ( Index = InsertionIndex + 1;
         Index < MasterListCount;
         Index++ )
      {
        HighScoreBackUp_2 = (*(MasterList + Index ));
           
         (*(MasterList + Index )) = 
         
             HighScoreBackUp_1;
         
        HighScoreBackUp_1 = HighScoreBackUp_2;       
                
      }  
             
}

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8 

void DisplayHighScores ( struct HighScores* MasterList,
                         const short MasterListCount )
{
    short Index, High, PlayerCount, Speed, AutoSpeedFlag;
    long Score;
    
    FontSetSys ( F_6x8 );
    clrscr();
    
    printf("   * * High Scores * *\n\n");
    
    for ( Index = 0; Index < MasterListCount; Index++ )
        {
          High = (*(MasterList + Index)).High;
          PlayerCount = (*(MasterList + Index)).PlayerCount;
          Speed = (*(MasterList + Index)).Speed;
          AutoSpeedFlag = (*(MasterList + Index)).Speed;
          Score = (*(MasterList + Index)).Score;
         
          printf("%-10s ", (*(MasterList + Index)).Name );
          printf("P%d ", PlayerCount );
          printf("S%02 ", Speed );
          
          if ( AutoSpeedFlag )
               printf("AS ");
          else
               printf("CS ");
           
          printf("%ld\n", Score );
          
          if ( !( (Index + 1) % HIGH_SCORES_PER_PAGE ))
             {
                  printf("Press any key...");
                  MenuWaitKey(100);
                  clrscr();
                  printf("\n");
             }
        }
    
}

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8

void DoHighScores ( struct HighScores* MasterList,
                    const short MasterListCount,
                    const struct GameOptions* MyGameOptions,
                    const struct PlayField* MyPlayField )
{
   struct HighScores MyScore;
   short InsertionIndex;
   
   MyScore.High        = MyGameOptions->High;
   MyScore.PlayerCount = MyGameOptions->PlayerCount;
   MyScore.Speed       = MyGameOptions->ViewerFallSpeed;
   MyScore.AutoSpeedFlag = MyGameOptions->AutoSpeedIncreaseFlag;
   MyScore.Score         = MyPlayField->ScoreValue;
   
   FontSetSys ( F_6x8 );
   clrscr();
   
   InsertionIndex = CompareHighScores ( MasterList, &MyScore,
                            MasterListCount ); 
   
   if ( InsertionIndex !=  COMPARE_HIGH_SCORES_RETURN_NEGATIVE )
      {
        printf("Enter your name:\n\n");
        SuperGets ( MyScore.Name, HIGH_SCORE_NAME_LENGTH - 1);

        InsertMyScore ( MasterList, &MyScore,
                        MasterListCount,
                        InsertionIndex );
                        
        DisplayHighScores ( MasterList, MasterListCount );
      }
} 

#endif
