
//#include "D:\TIGCC\Projects\Blocks\gameio.c"
//#include "D:\TIGCC\Projects\Blocks\drawtext.c"

#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\gameio.c"
#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\drawtext.c"

//#include "D:\TIGCC\Projects\Blocks\Special.c"
#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\Special.c"

#include <stdlib.h>
#include <alloc.h>
#include <mem.h>
#include <string.h>
#include <graph.h>
#include <stdio.h>

/*
#define FIXED_SCORE_X      CELL_WIDTH_PIXELS * 17
#define FIXED_SCORE_Y      CELL_HEIGHT_PIXELS * 1
*/

//00000000000000000000000000000000000000000000000000000000000000000000000

/*

struct PlayField
{
    char Field[PLAYFIELD_HEIGHT][PLAYFIELD_WIDTH];

    short LeftBoundary;
    short RightBoundary;

    short  ScoreX;
    short  ScoreY;
    long  ScoreValue;
    char ScoreText[PLAYFIELD_TEXT_LENGTH];
    char ScoreValueString[PLAYFIELD_TEXT_LENGTH];

    short  LevelX;
    short  LevelY;
    short  LevelValue;
    char LevelText[PLAYFIELD_TEXT_LENGTH];
    char LevelValueString[PLAYFIELD_TEXT_LENGTH];

    short  LinesCompletedX;
    short  LinesCompletedY;
    long  LinesValue;
    char LinesText[PLAYFIELD_TEXT_LENGTH];
    char LinesValueString[PLAYFIELD_TEXT_LENGTH];

    short NextTetradX;
    short NextTetradY;
    short NextTetradType;
    
    void* VirtualScreen;
    
    short RowClearCount;
    short High;
    short NextPiece;
};

*/

//00000000000000000000000000000000000000000000000000000000000000000000000


void InitializePlayField ( struct PlayField *MyPlayField );

void InitializePlayFieldValues ( struct PlayField *MyPlayField,
                                 struct GameOptions *MyGameOptions );

void GenerateRandomBlocks ( struct PlayField *MyPlayField, short HeightBlocks,
                            short GravityDirection );

void DoPlayField ( struct PlayField *MyPlayField,
                   struct BlockPic *MyBlockPic );

void DrawPlayFieldArea ( struct PlayField *MyPlayField );

   void DrawPlayFieldScore ( struct PlayField *MyPlayField );

   void DrawPlayFieldLevel ( struct PlayField *MyPlayField );

   void DrawPlayFieldLines ( struct PlayField *MyPlayField );

   void DrawPlayFieldNextTetrad ( struct PlayField *MyPlayField,
                                  struct BlockPic *MyBlocPic );
                                  
void UpdatePlayFieldValues ( struct PlayField *MyPlayField );


//00000000000000000000000000000000000000000000000000000000000000000000000

// DEBUG: include additional short argument for HIGH value
//     Add call to GenerateRandomBlocks ()   

void InitializePlayField ( struct PlayField *MyPlayField )
{
     short Xindex, Yindex;

     for ( Yindex = 0;  Yindex < PLAYFIELD_HEIGHT; Yindex++ )
       for ( Xindex = 0; Xindex < PLAYFIELD_WIDTH; Xindex++ )
           {
            MyPlayField->Field[Yindex][Xindex] = EMPTY_CELL_COLOR;

            if ( Xindex == PLAYFIELD_WALL_1_X ||
                 Xindex == PLAYFIELD_WALL_2_X )
                 MyPlayField->Field[Yindex][Xindex] = PLAYFIELD_WALL_COLOR;
           }

     MyPlayField->ScoreX       = CELL_WIDTH_PIXELS * 17;
     MyPlayField->ScoreY       = CELL_HEIGHT_PIXELS * 1;
     strcpy ( MyPlayField->ScoreText, "SCORE" );

     MyPlayField->LevelX       =  CELL_WIDTH_PIXELS * 17;
     MyPlayField->LevelY       = CELL_HEIGHT_PIXELS * 4;
     MyPlayField->LevelValue   = 0;
     strcpy ( MyPlayField->LevelText, "SPEED" );

     MyPlayField->LinesCompletedX =  CELL_WIDTH_PIXELS * 17;
     MyPlayField->LinesCompletedY =  CELL_HEIGHT_PIXELS * 7;
     MyPlayField->LinesValue      =  0;
     strcpy ( MyPlayField->LinesText, "LINES" );

     MyPlayField->NextTetradX     = 17;
     MyPlayField->NextTetradY     = 10;
     
     MyPlayField->LeftBoundary  =  PLAYFIELD_WALL_1_X;
     MyPlayField->RightBoundary =  PLAYFIELD_WALL_2_X;
     
     MyPlayField->VirtualScreen = malloc ( LCD_SIZE );
     
     // Clear the virtual screen
     
     memset (MyPlayField->VirtualScreen, 0, LCD_SIZE );
     
     MyPlayField->NextPiece = true;
}

//00000000000000000000000000000000000000000000000000000000000000000000000

void GenerateRandomBlocks ( struct PlayField *MyPlayField, short HeightBlocks,
                            short GravityDirection )
{
  short Xindex, Yindex;
  short YStartIndex, YEndIndex;
  short XStartIndex, XEndIndex;
  short GapsCreated;

  if ( HeightBlocks > 0 )
     {
            XStartIndex = PLAYFIELD_WALL_1_X + 1;
            XEndIndex   = PLAYFIELD_WALL_2_X - 1;

       if ( GravityDirection > 0 )
          {
            YEndIndex = PLAYFIELD_HEIGHT;
            YStartIndex = PLAYFIELD_HEIGHT - HeightBlocks;
          }
       else
       if ( GravityDirection < 0 )
          {
            YStartIndex = 0;
            YEndIndex = HeightBlocks;
          }

      // Completely fill the specified section of the playfield area
      // while randomly poking holes

      for ( Yindex = YStartIndex; Yindex <= YEndIndex; Yindex++ )
        {
            GapsCreated = 0;

         for ( Xindex = XStartIndex; Xindex <= XEndIndex; Xindex++ )
           {
                  MyPlayField->Field[Yindex][Xindex] =
                     random ( TETRAD_CELL_MAX_COLORS );

             if ( MyPlayField->Field[Yindex][Xindex] == EMPTY_CELL_COLOR )
                  GapsCreated++;
           }

            if ( GapsCreated <= 0 )
                 MyPlayField->Field[Yindex][Xindex - 1] = EMPTY_CELL_COLOR;

        }

    }
}

//00000000000000000000000000000000000000000000000000000000000000000000000

void InitializePlayFieldValues ( struct PlayField *MyPlayField,
                                 struct GameOptions *MyGameOptions )
{
     MyPlayField->ScoreValue = 0;
     
     sprintf( MyPlayField->ScoreValueString, "%d", 0 );
     
     MyPlayField->LevelValue = MyGameOptions->ViewerFallSpeed;
     
     sprintf( MyPlayField->LevelValueString, "%d", MyGameOptions->ViewerFallSpeed);
     
     if ( MyGameOptions->High == 0 )
        {
          MyPlayField->LinesValue = 0;
          sprintf( MyPlayField->LinesValueString, "%d", 0 );
        }
     else
        {
          MyPlayField->LinesValue = HIGH_GAME_LINES_NEED_CLEARING;
          sprintf( MyPlayField->LinesValueString, "%d", 
          HIGH_GAME_LINES_NEED_CLEARING );
        }
      
      MyPlayField->High = MyGameOptions->High;
}                                

//00000000000000000000000000000000000000000000000000000000000000000000000

void DoPlayField ( struct PlayField *MyPlayField,
                   struct BlockPic *MyBlockPic )
{
    if ( MyGameKeys.Pause )
         MyPlayField->NextPiece = false;
    
    DrawPlayFieldArea ( MyPlayField );

    DrawPlayFieldScore ( MyPlayField );

    DrawPlayFieldLevel ( MyPlayField );

    DrawPlayFieldLines ( MyPlayField );

    if ( MyPlayField->NextPiece )
         DrawPlayFieldNextTetrad ( MyPlayField, MyBlockPic );
}

//00000000000000000000000000000000000000000000000000000000000000000000000

void DrawPlayFieldArea ( struct PlayField *MyPlayField )
{
     short Xindex, Yindex, DestXindex, DestYindex;;
     char BlockColor;

     for ( Yindex = 0; Yindex < PLAYFIELD_HEIGHT; Yindex++ )
        for ( Xindex = 0; Xindex < PLAYFIELD_WIDTH; Xindex++ )
            {
              BlockColor = MyPlayField->Field[Yindex][Xindex];

            if ( BlockColor != EMPTY_CELL_COLOR )
              DrawCell_Special ( Xindex, Yindex, BlockColor );

             }
}

//00000000000000000000000000000000000000000000000000000000000000000000000

void DrawPlayFieldScore ( struct PlayField *MyPlayField )
{
     // debug
     
     
  /*
     
     DrawStr ( MyPlayField->ScoreX,
               MyPlayField->ScoreY, 
               MyPlayField->ScoreText, A_REPLACE ); 
  */
  
  if ( gGrayScale )
     {
     DrawText ( FIXED_SCORE_X, FIXED_SCORE_Y, MyPlayField->ScoreText, 
                MyPlayField->VirtualScreen, SPRT_OR );
                
     DrawText ( FIXED_SCORE_X, FIXED_SCORE_Y + SPRITE8_HEIGHT, 
                MyPlayField->ScoreValueString, 
                MyPlayField->VirtualScreen, SPRT_OR );
      }
   else
      {
        DrawText ( FIXED_SCORE_X, FIXED_SCORE_Y, MyPlayField->ScoreText, 
                DarkLayer, SPRT_OR );
                
        DrawText ( FIXED_SCORE_X, FIXED_SCORE_Y + SPRITE8_HEIGHT, 
                MyPlayField->ScoreValueString, 
                DarkLayer, SPRT_OR );
      }

/*
   
     DrawText ( MyPlayField->ScoreX, MyPlayField->ScoreY, MyPlayField->ScoreText, 
                MyPlayField->VirtualScreen, SPRT_OR );
                
     DrawText ( MyPlayField->ScoreX, MyPlayField->ScoreY + SPRITE8_HEIGHT, 
                MyPlayField->ScoreValueString, 
                MyPlayField->VirtualScreen, SPRT_OR );
*/
     
      /*
     printf_xy ( CELL_WIDTH_PIXELS * 16,
                 CELL_HEIGHT_PIXELS * 1, 
                 "%s", MyPlayField->ScoreText ); 
     */
     
     //DrawCell ( MyPlayField->ScoreX, MyPlayField->ScoreY + 1,
       //         1 );
}

//00000000000000000000000000000000000000000000000000000000000000000000000

void DrawPlayFieldLevel ( struct PlayField *MyPlayField )
{

  if ( gGrayScale )
    {
     DrawText ( MyPlayField->LevelX, MyPlayField->LevelY, MyPlayField->LevelText, 
                MyPlayField->VirtualScreen, SPRT_OR );

     DrawText ( MyPlayField->LevelX, MyPlayField->LevelY + SPRITE8_HEIGHT,
                MyPlayField->LevelValueString, 
                MyPlayField->VirtualScreen, SPRT_OR );
    }
  else
    {
     DrawText ( MyPlayField->LevelX, MyPlayField->LevelY, MyPlayField->LevelText, 
                DarkLayer, SPRT_OR );

     DrawText ( MyPlayField->LevelX, MyPlayField->LevelY + SPRITE8_HEIGHT,
                MyPlayField->LevelValueString, 
                DarkLayer, SPRT_OR );    
    }
    
    /*
    // debug

     DrawCell ( MyPlayField->LevelX, MyPlayField->LevelY,
                1);
     DrawCell ( MyPlayField->LevelX, MyPlayField->LevelY + 1,
                1);
     */
}

//00000000000000000000000000000000000000000000000000000000000000000000000

void DrawPlayFieldLines ( struct PlayField *MyPlayField )
{
  if ( gGrayScale )
     {
     DrawText ( MyPlayField->LinesCompletedX, MyPlayField->LinesCompletedY, 
                MyPlayField->LinesText, 
                MyPlayField->VirtualScreen, SPRT_OR );
                
     DrawText ( MyPlayField->LinesCompletedX, 
                MyPlayField->LinesCompletedY + SPRITE8_HEIGHT,
                MyPlayField->LinesValueString, 
                MyPlayField->VirtualScreen, SPRT_OR );
      }
   else
      {
    
     DrawText ( MyPlayField->LinesCompletedX, MyPlayField->LinesCompletedY, 
                MyPlayField->LinesText, 
                DarkLayer, SPRT_OR );
                
     DrawText ( MyPlayField->LinesCompletedX, 
                MyPlayField->LinesCompletedY + SPRITE8_HEIGHT,
                MyPlayField->LinesValueString, 
                DarkLayer, SPRT_OR );
      }          
    /*
     // debug

     DrawCell ( MyPlayField->LinesCompletedX,
                MyPlayField->LinesCompletedY,
                1 );
     DrawCell ( MyPlayField->LinesCompletedX,
                MyPlayField->LinesCompletedY + 1,
                1 );
     */
}

//00000000000000000000000000000000000000000000000000000000000000000000000

void DrawPlayFieldNextTetrad ( struct PlayField *MyPlayField,
                               struct BlockPic *MyBlockPic )
{
     DrawTetrad  ( (char *)MyBlockPic->Data,
                           MyPlayField->NextTetradX,
                           MyPlayField->NextTetradY,
                           EMPTY_CELL_COLOR );
}

//00000000000000000000000000000000000000000000000000000000000000000000000

void UpdatePlayFieldValues ( struct PlayField *MyPlayField )
{
     short  RowClearCount;
     long Score;
     
     RowClearCount = MyPlayField->RowClearCount;
     
     if ( RowClearCount > 0 )
        {
        
          // Line Counter
        
          if ( MyPlayField->High == 0 )
             {
               MyPlayField->LinesValue += (long)RowClearCount;               
             }
          else
             {
               MyPlayField->LinesValue -= (long)RowClearCount;
               
               if ( MyPlayField->LinesValue < 0 )
                    MyPlayField->LinesValue = 0;
             }
             
          
           // Score Counter
           
           switch ( RowClearCount )
              {
                  case 1: Score = POINTS_LINES_COMPLETED_1;
                          break;
                  case 2: Score = POINTS_LINES_COMPLETED_2;
                          break;
                  case 3: Score = POINTS_LINES_COMPLETED_3;
                          break;
                  case 4: Score = POINTS_LINES_COMPLETED_4;
                          break;
                  default:
                          Score = 0;
                          break;
              }         
          
          /* * * Extra points for special effects * * */
          
          if ( gXFlip == 2 )
               Score += 2;
               
          if ( gYFlip == 2 )
               Score += 2;
          
           Score += gXDistort;
           Score += gYDistort;     
           
          if ( gShapeMorph )
               Score += 2;
          
          if ( gHolePunch && MyPlayField->High >= 5 )
               Score += 5;  
           
           Score += gXLean/2;
           Score += gYLean/2;     
           
          if ( gMirage1 )
               Score += 1;
          
         /* * * * * * * * * * * * * * * * * * * * * * */
          
           
          MyPlayField->ScoreValue += Score;          
          
          sprintf( MyPlayField->LinesValueString, "%ld", 
                   MyPlayField->LinesValue); 
                   
          sprintf( MyPlayField->ScoreValueString, "%ld", 
                   MyPlayField->ScoreValue);
        }

       
}

//00000000000000000000000000000000000000000000000000000000000000000000000

