
//0000000000000000000000000000000000000000000000000000000000000000000000

#ifndef GLOBAL_HEADER_DEFINED

#define GLOBAL_HEADER_DEFINED

#define TETRAD_PIC_WIDTH      4
#define TETRAD_PIC_HEIGHT     4
#define TETRAD_CLASSIC_COUNT  6
#define TETRAD_TYPE_COUNT     6 + 6
#define TETRAD_MAX_ROTATIONS  4

#define BLOCK_L_TETRAD        0
#define BLOCK_T_TETRAD        1
#define BLOCK_LONG_TETRAD     2
#define BLOCK_SQUARE_TETRAD   3
#define BLOCK_Z_TETRAD_1      4
#define BLOCK_Z_TETRAD_2      5

// Unconventional shapes

#define BLOCK_SHORT_TETRAD    6
#define BLOCK_SHORT_L_TETRAD  7
#define BLOCK_C_TETRAD        8
#define BLOCK_PLUS_TETRAD     9
#define BLOCK_ANGLE90_TETRAD  10
#define BLOCK_ARROW_TETRAD    11


#define EMPTY_CELL_COLOR      0x00

#define PLAYFIELD_WIDTH       21
#define PLAYFIELD_HEIGHT      16

//0000000000000000000000000000000000000000000000000000000000000000000000

#define FIELD_ARRAY_WIDTH  21
#define FIELD_ARRAY_HEIGHT 16

#define FIELD_BORDER_COLOR   8
#define GENERAL_FIELD_CELL_COLOR  7

#define FIELD_X_DISPLACE   80
#define FIELD_Y_DISPLACE   50

#define PLAYFIELD_TEXT_LENGTH 10
#define PLAYFIELD_WALL_1_X    5
#define PLAYFIELD_WALL_2_X    PLAYFIELD_WALL_1_X + 10

#define PLAYFIELD_WALL_COLOR   7
#define TETRAD_CELL_MAX_COLORS 12

#define TETRAD_CELL_WIDTH  4
#define TETRAD_CELL_HEIGHT 4

#define CELL_WIDTH_PIXELS   6
#define CELL_HEIGHT_PIXELS  6

  // The 3 lines below are for the GetGameKeys() function in
  // "gameio.cpp" only

#define INITIALIZE_GAME_KEYS 0
#define GET_GAME_KEYS        1
#define EXIT_GAME_KEYS       2

//0000000000000000000000000000000000000000000000000000000000000000000000

// used in Field.c

#define SPRITE8_HEIGHT       8

//0000000000000000000000000000000000000000000000000000000000000000000000

enum bool { false, true };

#endif


