// C Source File
// Created 12/22/04; 2:02:44 PM

#ifndef GETS_C_DEFINED

      #define GETS_C_DEFINED

#include <compat.h>
#include <stdio.h>
#include <graph.h>
#include <string.h>
#include <kbd.h>

//000000000000000000000000000000000000000000000000000000000000000000000000000

#define STRING_OPERATION_SIZE 100

//000000000000000000000000000000000000000000000000000000000000000000000000000


char* StringRight ( char InputString[], short CharCount );

void SuperGets ( char InputString[], short MaxLength );

void RemoveTrailingDigits ( char InputString[] );


//000000000000000000000000000000000000000000000000000000000000000000000000000

char* StringRight ( char InputString[], short CharCount )
{
      static char ReturnString[STRING_OPERATION_SIZE];
      static short  InputStringLength;
      static short  SourceIndex;
      static short  DestIndex;
      
      InputStringLength = strlen ( InputString );
      
      SourceIndex = InputStringLength - CharCount;
      
      if ( SourceIndex < 0 )
           SourceIndex = 0;
      
      ReturnString[0] = NULL;
      
      DestIndex = 0;
      
     if ( InputStringLength > 0 )
      while (1)
        {        
            ReturnString[DestIndex] = InputString[SourceIndex];
            
          if ( SourceIndex < InputStringLength )
              {
               SourceIndex++;
               DestIndex++;
              };
              
               CharCount--;
              
              
             if ( CharCount <= 0 )
                 break;
        }
        
        ReturnString[DestIndex] = 0;
        
        return ReturnString;
}

//000000000000000000000000000000000000000000000000000000000000000000000000000

void SuperGets ( char InputString[], short MaxLength )
{
     short  Index;
     short  Key;

     // used here to restore cursor position

     SCR_STATE ScreenStateBackUp;   
     
     SaveScrState ( &ScreenStateBackUp );
     
     InputString[0] = NULL;
     
     Index = 0;
     
     while (1)
       {
          RestoreScrState( &ScreenStateBackUp );
          
          printf(" %s_ ", StringRight( InputString, 20 ) );
          
          Key = ngetchx();
          
          InputString[Index] = (char)Key;
          InputString[Index + 1] = NULL; 
          
          if ( Key != KEY_BACKSPACE )
               Index++;
          else
          if ( Key== KEY_BACKSPACE )
             {
               InputString[Index] = NULL;
               
               if ( Index > 0 )
                  {
                    Index--;
                    
                    InputString[Index] = NULL ;
                  }
             }
             
          if ( Index + 1 > MaxLength )
               break;         
          
          if ( Key == KEY_ENTER )
             {
               InputString[Index-1] = NULL;
               break;
             }
       }
       
       InputString[Index] = NULL;
       
       printf("\n");
}

//000000000000000000000000000000000000000000000000000000000000000000000000000

void RemoveTrailingDigits ( char InputString[] )
{
     short StringLength;
     short Index;
     unsigned char c;
     
     StringLength = strlen(InputString);
     
     for ( Index = 0; Index < StringLength; Index++ )
         {
           c = InputString[Index];
           
           if ( ( '0' <= c && c <= '9' ) || ( c == '.' ) )
                 ; // null statement
           else
              {
                 InputString[Index] = NULL;
                 break;
              }  
         }
}

//000000000000000000000000000000000000000000000000000000000000000000000000000

/*

// Main Function
void _main(void)
{

	char buffer[100];
	
	
	 FontSetSys ( F_6x8 );
	 
	 
	 clrscr();
	  	
	 printf(" Enter something ...\n\n" );
	 
	 SuperGets ( buffer, 90 );
	
	 printf(" You've entered \n %s ", buffer );
	 
	 
	 while (1)
	   {
	   
	        BEGIN_KEYTEST      
	         if ( !(  _keytest_optimized (RR_LEFT)
                || _keytest_optimized (RR_RIGHT)       
                || _keytest_optimized (RR_UP)
                || _keytest_optimized (RR_DOWN)) 
                
               && ( _keytest_optimized (RR_1) ) )
               break;

           END_KEYTEST
           
           
         
       

	   }
}


// enum Fonts {F_4x6, F_6x8, F_8x10}; 

*/

#endif
