/*
    Author:        Coldplastic Software
    Start Date:    12/03/04
    Last Update:   12/27/04
    Revision:      01/08/05 - 01/10/05
*/

#define EXECUTE_IN_GHOST_SPACE
#define ENABLE_ERROR_RETURN

/*
#include "D:\TIGCC\Projects\Blocks\tetrad.c"
#include "D:\TIGCC\Projects\Blocks\field.c"
#include "D:\TIGCC\Projects\Blocks\globals.h"
#include "D:\TIGCC\Projects\Blocks\glob_var.h"
#include "D:\TIGCC\Projects\Blocks\lines.c"
#include "D:\TIGCC\Projects\Blocks\Menu.c"
#include "D:\TIGCC\Projects\Blocks\drawtext.c"
#include "D:\TIGCC\Projects\Blocks\BackDrop.c"
#include "D:\TIGCC\Projects\Blocks\Misc.c"
#include "D:\TIGCC\Projects\Blocks\Scores.c"
#include "D:\TIGCC\Projects\Blocks\Link.c"
*/


#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\tetrad.c"
#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\field.c"
#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\globals.h"
#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\glob_var.h"
#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\lines.c"
#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\Menu.c"
#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\drawtext.c"
#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\BackDrop.c"
#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\Misc.c"
#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\Scores.c"
#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\Link.c"

//#include "D:\TIGCC\Projects\Blocks\Special.c"
#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\Special.c"

#include <gray.h>
#include <graph.h>

#include <alloc.h>
#include <stdlib.h>

#define HIGH_SCORES_TOTAL 16

struct HighScores MasterScoreList[HIGH_SCORES_TOTAL] = {0};

char FirstTimeUseFlag = 0;

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*

void RunGame ( struct GameOptions *MyGameOptions );

void CopyGameOptions2Templates ( struct GameOptions *MyGameOptions,
                                 struct DroppingBlock *MyDroppingBlock );   
                                                         
//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*

void _main ()
{
      static struct GameOptions MyGameOptions = {0};
      short MenuOption;
      
      if ( !FirstTimeUseFlag )
         {
           InitializeGameOptions ( &MyGameOptions );   
      
           InitializeHighScores ( &MasterScoreList, 
                                  HIGH_SCORES_TOTAL );         
           
           FirstTimeUseFlag = 1;
         }
                
	    DoTitle();
	    
	    while (1)
	      {
          MyGameOptions.ExitGameFlag = FALSE;
      	  
      	  MenuOption = MainMenuScreen(); 
      	      
	        InterpreteMainMenuOptions ( MenuOption, &MyGameOptions );
          
          if ( MyGameOptions.ExitGameFlag == TRUE )
               break;
      /*                         clrscr();
      printf("1 %d %d %d %d %d\n", MyGameOptions.RealFallSpeed,
                MyGameOptions.ViewerFallSpeed,
                MyGameOptions.ReverseGravityFlag,
                MyGameOptions.NewPiecesFlag,
                MyGameOptions.GravityDirection ); // debug
                MenuWaitKey(100);     
      */
       
        /*      
          if ( MenuOption == ONE_PLAYER_GAME ||
               MenuOption == TWO_PLAYER_GAME  )
               RunGame ( &MyGameOptions );
         */ 
         
          if ( MenuOption == ONE_PLAYER_GAME )
               RunGame ( &MyGameOptions );
               
          if ( MenuOption == HIGH_SCORES )
          
               DisplayHighScores ( &MasterScoreList, 
                              HIGH_SCORES_TOTAL );   
               
	      }
}

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*

void RunGame ( struct GameOptions *MyGameOptions )
{
/*
void InitializePlayField ( struct PlayField & );

void GenerateRandomBlocks ( struct PlayField &, int, short );

void DoPlayField ( struct PlayField &, struct BlockPic &, short );
*/
 
     //char Field[FIELD_ARRAY_HEIGHT][FIELD_ARRAY_WIDTH] = {{0}};
     
     static short DARK_PLANE_LAYER = 0;
     static short LIGHT_PLANE_LAYER = 0;

     static short DrawScreenFlag = 0;

     static struct PlayField MyPlayField = {{0}};

     static struct DroppingBlock DB = {{0}};

     static struct BlockPic Tetrads[TETRAD_TYPE_COUNT][TETRAD_MAX_ROTATIONS]
         = {{0}};
         
     static struct GameOptions MyGameOptionsCopy = {{0}};    
     
     // Link debug 
     
     static struct LinkVariables MyLinkVariables = {0};

     MyGameOptionsCopy = *MyGameOptions;

     /*
      printf("2 %d %d %d %d \n", MyGameOptions->RealFallSpeed,
                MyGameOptions->ViewerFallSpeed,
                MyGameOptions->ReverseGravityFlag,
                MyGameOptions->GravityDirection ); // debug
      */
 
     InitializeBlockPic( Tetrads );

     InitializeBlockTemplates ( &Block_Template_1, &Block_Template_2 );

     CopyGameOptions2Templates ( &MyGameOptionsCopy, 
                                 &Block_Template_1 );     
     CopyGameOptions2Templates ( &MyGameOptionsCopy, 
                                 &Block_Template_2 );

     InitializePlayField ( &MyPlayField );
     
     InitializePlayFieldValues ( &MyPlayField, &MyGameOptionsCopy );

     randomize  ();  // for tetrad.c module     
     
     /*
           printf("3** %d %d %d \n", 
                 Block_Template_1.MovementSpeed,
                 Block_Template_1.MovementSpeedBackUp,
                 Block_Template_1.GravityDirection ); // debug
     */

     NewBlock ( &DB,  MyGameOptionsCopy.GravityDirection ); //MyGameOptionsCopy.GravityDirection );

     /*
           printf("4** %d %d %d \n", 
                 DB.MovementSpeed,
                 DB.MovementSpeedBackUp,
                 DB.GravityDirection ); // debug
     */
    
    
     BackGroundLayer = malloc ( LCD_SIZE );
     
     InitializeBackGround ( BackGroundLayer, MyGameOptionsCopy.BackGroundIndex, 
                            &MyPlayField );


      // Link debug
      
      /*
      if ( MyGameOptionsCopy.PlayerCount == 2 )

         if ( !GrandLink( 0,
                          &MyLinkVariables,
                          &MyPlayField,
                          &MyGameOptionsCopy,
                          &DB ) )
              return;  // exit back to menu screen if link failed
       */   
    
	   //0000000000000000000000000000000000000000000000000
     // TIGCC specific
     
     if ( gGrayScale )
        {
          GrayScaleBuffer = malloc ( GRAYDBUFFER_SIZE );
	   
     	    GrayOn();
	        GrayDBufInit( GrayScaleBuffer );
	      }
	   else
	      {
	        DarkLayer = malloc (LCD_SIZE);
	        LightLayer = DarkLayer; 
	      }
	      
	   /*
           printf("4** %d %d %d \n", 
                 DB.MovementSpeed,
                 DB.MovementSpeedBackUp,
                 DB.GravityDirection ); // debug
	   */
	      
	   //GraySetSwitchCount (0);
	   
	   //0000000000000000000000000000000000000000000000000
 
      GenerateRandomBlocks ( &MyPlayField, MyGameOptionsCopy.High,
                              MyGameOptionsCopy.GravityDirection );

       /*
      printf("6) %d %d %d %d \n", MyGameOptions->RealFallSpeed,
                MyGameOptions->ViewerFallSpeed,
                MyGameOptions->ReverseGravityFlag,
                MyGameOptions->NewPiecesFlag ); // debug
                
      MenuWaitKey(100);
       */

      DoInitialSpecialEffects ();
      
      if ( gSwapLayers )
         {
           LIGHT_PLANE_LAYER = DARK_PLANE;
           DARK_PLANE_LAYER =  LIGHT_PLANE;
         }
      else
         {
           LIGHT_PLANE_LAYER = LIGHT_PLANE;
           DARK_PLANE_LAYER = DARK_PLANE;
         }
      
      while (1)
        {
            
	   //0000000000000000000000000000000000000000000000000
	     
	   if ( gGrayScale )
	      {   
	        LightLayer = GrayDBufGetHiddenPlane ( LIGHT_PLANE_LAYER );
	        DarkLayer = GrayDBufGetHiddenPlane ( DARK_PLANE_LAYER );
	      }
	      
	   //memset (LightLayer, 0, LCD_SIZE );
	   
	   memcpy (LightLayer, BackGroundLayer, LCD_SIZE );
	  
	   if ( gGrayScale ) 
	        memcpy (DarkLayer, MyPlayField.VirtualScreen, LCD_SIZE );
	   
	   //0000000000000000000000000000000000000000000000000
	   
           GetGameKeys( &MyGameKeys );
           UserMoveBlock ( &DB, &MyGameKeys,
                           &TetradActionFlag );

         if ( TetradActionFlag )
            {  
              if ( CheckBlockCollideStaticBlock (
                   &DB,
                  (struct BlockPic *)Tetrads, (char *)MyPlayField.Field) )
                {
                  if ( MyGameKeys.RotateLeft )
                       DB.RotationIndex = DB.RotationIndexOld;

                  if ( MyGameKeys.RotateRight )
                       DB.RotationIndex = DB.RotationIndexOld;

                  if ( MyGameKeys.Left || MyGameKeys.Right )
                       DB.x = DB.x_Old;
                }
                
                DrawScreenFlag = 1;  // Used only when Super Speed is turned on
             }

              DropBlock ( &DB, &TetradActionFlag );

        if ( TetradActionFlag )
           {
                DrawScreenFlag = 1;
                
                /* Special effects */
                
                RandomXYFlip ();
                RandomJerking ( &DB );
                RandomShapeMorph ( &DB );
                RandomShake ();
                RandomHolePunch ( &MyPlayField );
                Random_Mirage1 ();
                Generate_Mirage2Table (1);
                MoveTetradRain ();
                MoveCellRain ();
                
              if ( CheckBlockCollideStaticBlock (
                   &DB,
                  (struct BlockPic *)Tetrads, (char *)MyPlayField.Field) )
                {
                   DB.y = DB.y_Old;

                   PasteBlockField (
                   &DB,
                   (struct BlockPic *)Tetrads,
                   (char *)MyPlayField.Field );

                   MainClearRows ( &MyPlayField, 
                                    MyGameOptionsCopy.GravityDirection ); 
                   UpdatePlayFieldValues ( &MyPlayField );   
                   
                   // clear the text area
                   memset (MyPlayField.VirtualScreen, 0, LCD_SIZE );	   
                    
                   NewBlock ( &DB, MyGameOptionsCopy.GravityDirection );
                 
                 // Game over if overflow
                   
                 if ( CheckBlockCollideStaticBlock (
                      &DB,
                     (struct BlockPic *)Tetrads, (char *)MyPlayField.Field) )
                     {
                       MyGameOptionsCopy.GameState = GAME_STATE_LOSE;
                       break;
                     }
                     
                   AutoSpeedIncrease ( &MyGameOptionsCopy,
                                       &DB,
                                       &MyPlayField );
                   
                   if ( MyGameOptionsCopy.High > 0 && 
                        MyGameOptionsCopy.PlayerCount == 1 &&
                        MyPlayField.LinesValue <= 0 )
                      {
                         MyGameOptionsCopy.GameState = GAME_STATE_WIN;
                         break;                        
                      }
                }
              else
              if ( CheckBlockCollideBoundaryY (
                   &DB,
                  (struct BlockPic *)Tetrads ))
              {
                   DB.x = DB.x_Old;
                   DB.y = DB.y_Old;

                   PasteBlockField (
                   &DB,
                   (struct BlockPic *)Tetrads,
                   (char *)MyPlayField.Field );

                   MainClearRows ( &MyPlayField, 
                                   MyGameOptionsCopy.GravityDirection );
                   UpdatePlayFieldValues ( &MyPlayField );  
                   
                   // clear the text area
                   memset (MyPlayField.VirtualScreen, 0, LCD_SIZE );	   

                   NewBlock ( &DB, MyGameOptionsCopy.GravityDirection  );
                   
                   // Game over if overflow
                   
                   if ( CheckBlockCollideStaticBlock (
                        &DB,
                       (struct BlockPic *)Tetrads, (char *)MyPlayField.Field) )
                      {
                        MyGameOptionsCopy.GameState = GAME_STATE_LOSE;
                        break;
                      }

                   AutoSpeedIncrease ( &MyGameOptionsCopy,
                                       &DB,
                                       &MyPlayField );

                   if ( MyGameOptionsCopy.High > 0 && 
                        MyGameOptionsCopy.PlayerCount == 1 &&
                        MyPlayField.LinesValue <= 0 )
                      {
                         MyGameOptionsCopy.GameState = GAME_STATE_WIN;
                         break;                        
                      }
               }
          }

      if ( gSuperSpeed )
       {
        if ( DrawScreenFlag )
          {
           DoPlayField ( &MyPlayField, &Tetrads[DB.NextType][0] );

            /* Special Effects */
            
           DrawBlock_Special ( &DB, (struct BlockPic *)Tetrads );     
           Draw_Mirage2Table (); 
           DrawTetradRain ( (struct BlockPic *)Tetrads );          
           DrawCellRain ();
          } 
      }
     else
      {
           DoPlayField ( &MyPlayField, &Tetrads[DB.NextType][0] );

            /* Special Effects */
            
           DrawBlock_Special ( &DB, (struct BlockPic *)Tetrads );     
           Draw_Mirage2Table (); 
           DrawTetradRain ( (struct BlockPic *)Tetrads );          
           DrawCellRain ();
      }
    
      
           if ( MyGameKeys.Quit )
              {
                MyGameOptionsCopy.GameState = GAME_STATE_QUIT;
                break;
              }
              
          // Link.c function debug
         
         /*
          if ( _keytest( RR_F4 ))
              AddRowsPlayField ( &MyPlayField, 
                                 4,
                                 1);
          */ 
       /*      
          if ( MyGameOptionsCopy.PlayerCount == 2 )
               GrandLink( 1,
                         &MyLinkVariables,
                         &MyPlayField,
                         &MyGameOptionsCopy,
                         &DB );        
        */
        
         // TIGCC specific
                 

    if ( gSuperSpeed )
      {
       if ( DrawScreenFlag )
          {      
             if ( gGrayScale )
                {
                  GrayDBufToggleSync(); 
                  GraySetSwitchCount (0);            
         	        while ( GrayGetSwitchCount() < 2 );
         	      }
         	   else
            	   memcpy (LCD_MEM, LightLayer, LCD_SIZE );
            	   
             DrawScreenFlag = 0;
          }
       }
     else
       {
            if ( gGrayScale )
                {
                  GrayDBufToggleSync(); 
                  GraySetSwitchCount (0);            
         	        while ( GrayGetSwitchCount() < 2 );
         	      }
         	   else
            	   memcpy (LCD_MEM, LightLayer, LCD_SIZE );
       }
              	        
       }
       
        GameMessage ( &MyGameOptionsCopy, 
                       DarkLayer, LightLayer );

        // TIGCC specific
        	GrayOff ();		  
        	
         
         free ( MyPlayField.VirtualScreen );
     
         if ( gGrayScale )
              free ( GrayScaleBuffer );
         else
              free ( LightLayer );
   
         free ( BackGroundLayer );
         
         DoHighScores ( &MasterScoreList,
                        HIGH_SCORES_TOTAL,
                        &MyGameOptionsCopy,
                        &MyPlayField );  
         
         // debug
         /*
         clrscr();
         printf("RowClearCount = %d\n", MyPlayField.RowClearCount );
         printf("Lines         = %ld\n", MyPlayField.LinesValue);
         printf("Score         = %ld\n", MyPlayField.ScoreValue );
         MenuWaitKey(100);
         */
        	 
}

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*

void CopyGameOptions2Templates ( 
                          
                       struct GameOptions *MyGameOptions,
                       struct DroppingBlock *MyDroppingBlock )
{
    

  MyDroppingBlock->MovementSpeed = MyGameOptions->RealFallSpeed;
  
  MyDroppingBlock->MovementSpeedBackUp = 
            MyGameOptions->RealFallSpeed;
     
  switch ( MyGameOptions->NewPiecesFlag )
     {
         case FALSE: MyDroppingBlock->MaxPieceTypes =
                     TETRAD_CLASSIC_COUNT ;
                     break;
                     
         case TRUE:  MyDroppingBlock->MaxPieceTypes =
                     TETRAD_TYPE_COUNT;
                     break;
         default: MyDroppingBlock->MaxPieceTypes = 
                  TETRAD_CLASSIC_COUNT;
                  break;
     }    
}                      
  

//8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*8*