// C Source File
// Created 12/24/04; 1:33:02 PM

#ifndef MISC_C_DEFINED
  
      #define MISC__C_DEFINED

/*
#include "D:\TIGCC\Projects\Blocks\glob_var.h"
#include "D:\TIGCC\Projects\Blocks\DrawText.c"
#include "D:\TIGCC\Projects\Blocks\Menu.c"
*/

#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\glob_var.h"
#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\DrawText.c"
#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\Menu.c"

#include <stdio.h>
#include <string.h>
#include <compat.h>
#include <gray.h>

#define GAME_MESSAGE_LENGTH  10
#define GAME_MESSAGE_X       LCD_WIDTH/2 - 8 * 6
#define GAME_MESSAGE_Y       LCD_HEIGHT/2

//00000000000000000000000000000000000000000000000000000000000000000000000000

void AutoSpeedIncrease ( struct GameOptions *MyGameOptions,
                         struct DroppingBlock *MyDroppingBlock,
                         struct PlayField *MyPlayField );  

void GameMessage ( struct GameOptions *MyGameOptions,
                   void *DarkBufferLayer,
                   void *LightBufferLayer );

//00000000000000000000000000000000000000000000000000000000000000000000000000

void AutoSpeedIncrease ( struct GameOptions *MyGameOptions,
                         struct DroppingBlock *MyDroppingBlock,
                         struct PlayField *MyPlayField )
{

  short MovementSpeed;

 if ( MyPlayField->RowClearCount > 0 )
  {
   if ( MyGameOptions->AutoSpeedIncreaseFlag && 
        ( MyGameOptions->High > 0 ? 
          MyPlayField->LinesValue > 0 : 
          MyPlayField->LinesValue < HIGH_GAME_LINES_NEED_CLEARING ))
       
     if ( ! (MyPlayField->LinesValue % AUTO_SPEED_INCREMENT_INTERVAL ) )
        {
            
            MovementSpeed = DROP_SPEED_ADJUSTMENT - MyPlayField->LevelValue;        
            
         if ( MovementSpeed > 1 )
            {       
              (MyPlayField->LevelValue)++;
       
              MovementSpeed--;

              MyDroppingBlock->MovementSpeed = MyDroppingBlock->MovementSpeedBackUp 
                = MovementSpeed;
            
              sprintf( MyPlayField->LevelValueString, "%d", MyPlayField->LevelValue );
            
            }
        }
        
   }
  else
    {
       MovementSpeed = DROP_SPEED_ADJUSTMENT - MyPlayField->LevelValue; 
       
       MyDroppingBlock->MovementSpeed = MyDroppingBlock->MovementSpeedBackUp 
                = MovementSpeed;  
    }
}
                         
                         
//00000000000000000000000000000000000000000000000000000000000000000000000000     

void GameMessage ( struct GameOptions *MyGameOptions,
                   void *DarkBufferLayer,
                   void *LightBufferLayer )
{
     char Message[GAME_MESSAGE_LENGTH];
     char BlankString[] = "          ";
     
     switch ( MyGameOptions->GameState )
       {
            case GAME_STATE_WIN: strcpy ( Message, " YOU WIN  " );
                                  break;
                                  
            case GAME_STATE_LOSE: strcpy ( Message,  " YOU LOSE " );
                                  break;
                                  
            case GAME_STATE_QUIT:                   
                        
            default: strcpy ( Message,  " YOU QUIT " );
                     break;
       }
       
       // Create horizontal white space area first
       
     DrawText ( GAME_MESSAGE_X, GAME_MESSAGE_Y, 
                BlankString, DarkBufferLayer, SPRT_AND );

     DrawText ( GAME_MESSAGE_X, GAME_MESSAGE_Y, 
                BlankString, LightBufferLayer, SPRT_AND );
                

      // Write Message

     DrawText ( GAME_MESSAGE_X, GAME_MESSAGE_Y, 
                Message, DarkBufferLayer, SPRT_OR );

     DrawText ( GAME_MESSAGE_X, GAME_MESSAGE_Y, 
                Message, LightBufferLayer, SPRT_OR );
  
    if ( gGrayScale )
        GrayDBufToggleSync();    
    else           
        memcpy (LCD_MEM, LightLayer, LCD_SIZE );     
     
     MenuWaitKey (100);
}

//00000000000000000000000000000000000000000000000000000000000000000000000000 
                   

#endif
                    
                                    