

/*
#include "D:\TIGCC\Projects\Blocks\gameio.c"
#include "D:\TIGCC\Projects\Blocks\blocks.c"
#include "D:\TIGCC\Projects\Blocks\globals.h"
#include "D:\TIGCC\Projects\Blocks\glob_var.h"
*/



#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\gameio.c"
#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\blocks.c"
#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\globals.h"
#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\glob_var.h"

//#include "D:\TIGCC\Projects\Blocks\Special.c"
#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\Special.c"



#include <stdlib.h>

//00000000000000000000000000000000000000000000000000000000000000000000000000

/*

     struct BlockPic
       {
         char Data[TETRAD_PIC_WIDTH][TETRAD_PIC_WIDTH];
       };

     struct DroppingBlock
       {
          short x, y;
          short x_Old, y_Old;
          short Xstart, Ystart;

          short MovementCounter;
          short RotationCounter;

          short MovementSpeed;
          short MovementSpeedBackUp;
          short SuperMovementSpeed;

          short RotationSpeed;
          short Type;
          short NextType;
          short RotationIndex;
          short RotationIndexOld;
          short GravityDirection;

          short MaxMovementCount;

          short CollisionBoundaryY;

          char ClearColor;
      };

     struct GameKeys
       {
         char Up, Down, Left, Right;
         char RotateLeft, RotateRight;
         char Pause, Quit;

       };

*/

//00000000000000000000000000000000000000000000000000000000000000000000000000

  void DropBlock ( struct DroppingBlock * MyDroppingBlock,
                   char *ActionFlag );

     // struct GameKeys *   should reference a global struct thats
     // updated regulary with a function in "gameio.cpp"

  void UserMoveBlock ( struct DroppingBlock * MyDroppingBlock,
                     struct GameKeys * MyGameKeys,
                     char *ActionFlag );

  enum bool CheckBlockCollideBoundaryY ( struct DroppingBlock * MyDroppingBlock,
                                  struct BlockPic *BlocksArray );

  enum bool CheckBlockCollideStaticBlock ( struct DroppingBlock * MyDroppingBlock,
                                    struct BlockPic *BlocksArray,
                                    char *BlockFieldPtr );

  void PasteBlockField ( struct DroppingBlock * MyDroppingBlock,
                         struct BlockPic *BlocksArray,
                         char *BlockFieldPtr );

    // Sets up global block templates

  void InitializeBlockTemplates ( struct DroppingBlock * Template_1,
                                  struct DroppingBlock * Template_2 );

    // At start of game and after a block touches ground or another block,
    // this function is called. Uses global block templates

  void NewBlock ( struct DroppingBlock * EmptyBlock, short TemplateChoice );


   //  calls function in "gameio.cpp"

  void DrawBlock ( struct DroppingBlock * MyDroppingBlock,
                 struct BlockPic *BlocksArray );

  void DrawBlock_Special ( struct DroppingBlock * MyDroppingBlock,
                 struct BlockPic *BlocksArray );


//00000000000000000000000000000000000000000000000000000000000000000000000000

void DropBlock ( struct DroppingBlock * MyDroppingBlock,
                 char *ActionFlag )
{
     *ActionFlag = false;

     if ( MyDroppingBlock->MovementCounter %
          MyDroppingBlock->MovementSpeed == 0 )
        {
          *ActionFlag = true;	
         
          MyDroppingBlock->x_Old = MyDroppingBlock->x;
          MyDroppingBlock->y_Old = MyDroppingBlock->y;
          MyDroppingBlock->y += MyDroppingBlock->GravityDirection;
         
        }

     MyDroppingBlock->MovementCounter++;

     if ( MyDroppingBlock->MovementCounter >
          MyDroppingBlock->MaxMovementCount )
          MyDroppingBlock->MovementCounter = 0;
}

//00000000000000000000000000000000000000000000000000000000000000000000000000

void UserMoveBlock ( struct DroppingBlock * MyDroppingBlock,
                     struct GameKeys * MyGameKeys,
                     char *ActionFlag )
{

     *ActionFlag = false;

     if ( MyDroppingBlock->RotationCounter %
          MyDroppingBlock->RotationSpeed == 0 )
        {
         
            if ( MyGameKeys->RotateLeft == 1 )
               {
                 *ActionFlag = true;	 
               
                 MyDroppingBlock->RotationIndexOld =
                 MyDroppingBlock->RotationIndex;

                 MyDroppingBlock->RotationIndex--;

                 if ( MyDroppingBlock->RotationIndex < 0 )
                      MyDroppingBlock->RotationIndex = TETRAD_MAX_ROTATIONS-1;
               }

            if ( MyGameKeys->RotateRight == 1 )
               {
               	 *ActionFlag = true; 
                
                 MyDroppingBlock->RotationIndexOld =
                 MyDroppingBlock->RotationIndex;

                 MyDroppingBlock->RotationIndex++;

                 if ( MyDroppingBlock->RotationIndex > TETRAD_MAX_ROTATIONS-1 )
                      MyDroppingBlock->RotationIndex = 0;
               }

            if ( MyGameKeys->Right == 1 )
               {
                 *ActionFlag = true;	  
               
                  MyDroppingBlock->x_Old = MyDroppingBlock->x;
                  MyDroppingBlock->y_Old = MyDroppingBlock->y;
                  MyDroppingBlock->x += 1;
               }
            if ( MyGameKeys->Left == 1 )
               {
                 *ActionFlag = true;	
               
                  MyDroppingBlock->x_Old = MyDroppingBlock->x;
                  MyDroppingBlock->y_Old = MyDroppingBlock->y;
                  MyDroppingBlock->x -= 1;
               }


            if ( MyGameKeys->Down == 1 )
                MyDroppingBlock->MovementSpeed =
                MyDroppingBlock->SuperMovementSpeed;
            else
                MyDroppingBlock->MovementSpeed =
                MyDroppingBlock->MovementSpeedBackUp;

        }

     MyDroppingBlock->RotationCounter++;

     if ( MyDroppingBlock->RotationCounter >
          MyDroppingBlock->MaxMovementCount )
          MyDroppingBlock->RotationCounter = 0;

}

//00000000000000000000000000000000000000000000000000000000000000000000000000

enum bool CheckBlockCollideBoundaryY ( struct DroppingBlock * MyDroppingBlock,
                                  struct BlockPic *BlocksArray )
{
    short Xindex, Yindex, X, Y;

    Yindex = Xindex = 0;

    for ( Y = MyDroppingBlock->y ; Yindex < TETRAD_PIC_HEIGHT; Yindex++,
          Y++ )
      for ( X = MyDroppingBlock->x, Xindex = 0 ; Xindex < TETRAD_PIC_WIDTH;
            Xindex++, X++ )

        if ( (*(BlocksArray + MyDroppingBlock->Type * TETRAD_MAX_ROTATIONS
                       + MyDroppingBlock->RotationIndex )).Data[Yindex][Xindex]
               != MyDroppingBlock->ClearColor )

             if ( Y == MyDroppingBlock->CollisionBoundaryY )
                  return true;

    return false;

}

//00000000000000000000000000000000000000000000000000000000000000000000000000


enum bool CheckBlockCollideStaticBlock ( struct DroppingBlock * MyDroppingBlock,
                                    struct BlockPic *BlocksArray,
                                    char *BlockFieldPtr )
{
    short Xindex, Yindex, X, Y;

    for ( Y = MyDroppingBlock->y, Yindex = 0 ; Yindex < TETRAD_PIC_HEIGHT;
          Yindex++, Y++ )
      for ( X = MyDroppingBlock->x, Xindex = 0 ; Xindex < TETRAD_PIC_WIDTH;
            Xindex++, X++ )

        if ( (*(BlocksArray + MyDroppingBlock->Type * TETRAD_MAX_ROTATIONS
                    + MyDroppingBlock->RotationIndex )).Data[Yindex][Xindex]
               != MyDroppingBlock->ClearColor )

            if ( 0 <= X && X < PLAYFIELD_WIDTH &&
                 0 <= Y && Y < PLAYFIELD_HEIGHT )

             if ( *(BlockFieldPtr + X + Y * PLAYFIELD_WIDTH ) !=
                    MyDroppingBlock->ClearColor )
                  return true;

    return false;
}

//00000000000000000000000000000000000000000000000000000000000000000000000000

void PasteBlockField ( struct DroppingBlock * MyDroppingBlock,
                       struct BlockPic *BlocksArray,
                         char *BlockFieldPtr )
{
    short Xindex, Yindex, X, Y;

    Yindex = 0;

    for ( Y = MyDroppingBlock->y ; Yindex < TETRAD_PIC_HEIGHT; Yindex++,
          Y++ )
      for ( X = MyDroppingBlock->x, Xindex = 0; Xindex < TETRAD_PIC_WIDTH;
            Xindex++, X++ )

        if ( (*(BlocksArray + MyDroppingBlock->Type * TETRAD_MAX_ROTATIONS
                 + MyDroppingBlock->RotationIndex )).Data[Yindex][Xindex]
                 != MyDroppingBlock->ClearColor )

            if ( 0 <= X && X < PLAYFIELD_WIDTH &&
                 0 <= Y && Y < PLAYFIELD_HEIGHT )

               *(BlockFieldPtr + X + Y * PLAYFIELD_WIDTH ) =
               (*(BlocksArray + MyDroppingBlock->Type * TETRAD_MAX_ROTATIONS
                  + MyDroppingBlock->RotationIndex )).Data[Yindex][Xindex];


}

//00000000000000000000000000000000000000000000000000000000000000000000000000

    // Sets up global block templates

void InitializeBlockTemplates ( struct DroppingBlock * Template_1,
                                  struct DroppingBlock * Template_2 )
{
     Template_1->x                       = 10;
     Template_1->y                       = -2;
     Template_1->x_Old                   = Template_1->x;
     Template_1->y_Old                   = Template_1->y;
     Template_1->Xstart                  = Template_1->x;
     Template_1->Ystart                  = Template_1->y;
     Template_1->MovementSpeed           = 5;
     Template_1->SuperMovementSpeed      = 1;
     Template_1->MovementSpeedBackUp     = 5;
     Template_1->RotationSpeed           = 1;
     Template_1->RotationIndex           = 0;
     Template_1->RotationIndexOld        = 0;
     Template_1->Type                    = rand() % TETRAD_TYPE_COUNT;
     Template_1->NextType                = rand() % TETRAD_TYPE_COUNT;
     Template_1->GravityDirection        = 1;
     Template_1->MaxMovementCount        = 2000;
     Template_1->CollisionBoundaryY      = PLAYFIELD_HEIGHT;
     Template_1->ClearColor              = 0;

     Template_2->x                       = 10;
     Template_2->y                       = PLAYFIELD_HEIGHT;
     Template_2->x_Old                   = Template_2->x;
     Template_2->y_Old                   = Template_2->y;
     Template_2->Xstart                  = Template_2->x;
     Template_2->Ystart                  = Template_2->y;
     Template_2->MovementSpeed           = 5;
     Template_2->SuperMovementSpeed      = 1;
     Template_2->MovementSpeedBackUp     = 5;
     Template_2->RotationSpeed           = 1;
     Template_2->RotationIndex           = 0;
     Template_2->RotationIndexOld        = 0;
     Template_2->Type                    = rand() % TETRAD_TYPE_COUNT;
     Template_2->NextType                = rand() % TETRAD_TYPE_COUNT;
     Template_2->GravityDirection        = -1;
     Template_2->MaxMovementCount        = 2000;
     Template_2->CollisionBoundaryY      = -1;
     Template_2->ClearColor              = 0;
}

//00000000000000000000000000000000000000000000000000000000000000000000000000

    // At start of game and after a block touches ground or another block,
    // this function is called. Uses global block templates

void NewBlock ( struct DroppingBlock * EmptyBlock, short TemplateChoice )
{
     short NextTypeBackUp;

     NextTypeBackUp = EmptyBlock->NextType;

     switch ( TemplateChoice )
       {
           case BLOCK_TEMPLATE_NORMAL:

                *EmptyBlock = Block_Template_1;

                EmptyBlock->Type = NextTypeBackUp;
                EmptyBlock->NextType = 
                    random ( EmptyBlock-> MaxPieceTypes );
                break;

           case BLOCK_TEMPLATE_REVERSE:

                *EmptyBlock = Block_Template_2;

                EmptyBlock->Type = NextTypeBackUp;
                EmptyBlock->NextType =
                    random ( EmptyBlock-> MaxPieceTypes );
                break;

           default:
                  break;
       }
}

//00000000000000000000000000000000000000000000000000000000000000000000000000

void DrawBlock ( struct DroppingBlock * MyDroppingBlock,
                 struct BlockPic *BlocksArray )

{
     DrawTetrad ( (char *)(*(BlocksArray + MyDroppingBlock->Type *
                  TETRAD_MAX_ROTATIONS
                  + MyDroppingBlock->RotationIndex )).Data,

                  MyDroppingBlock->x, MyDroppingBlock->y,
                  EMPTY_CELL_COLOR );
}

//00000000000000000000000000000000000000000000000000000000000000000000000000

void DrawBlock_Special ( struct DroppingBlock * MyDroppingBlock,
                 struct BlockPic *BlocksArray )

{    
    short TetradType;
    
    if ( gSpriteMorph )
      if ( !random(SPRITE_MUTATION_CHANCE) )
         {
            short SwapIndex1, SwapIndex2;
            short SwapCount;
            char Cell1, Cell2, TempCell;
            
            for ( SwapCount = 0; SwapCount < SWAPS_PER_SPRITE_MORPH; SwapCount++ )
                {
                  SwapIndex1 = random(TETRAD_CELL_MAX_COLORS);
                  SwapIndex2 = random(TETRAD_CELL_MAX_COLORS); 
                  
                  Cell1 = CellSwapColors[SwapIndex1];
                  Cell2 = CellSwapColors[SwapIndex2];
                  
                  TempCell = Cell1;
                  Cell1 = Cell2;
                  Cell2 = TempCell;
                  
                  CellSwapColors[SwapIndex1] = Cell1;
                  CellSwapColors[SwapIndex2] = Cell2;
                }
            
         }
   
     if ( MyDroppingBlock->MaxPieceTypes == TETRAD_TYPE_COUNT )      
        TetradType = TetradSwapArray[MyDroppingBlock->Type];
     else
     if ( MyDroppingBlock->MaxPieceTypes == TETRAD_CLASSIC_COUNT )
        TetradType = TetradSwapArrayClassic[MyDroppingBlock->Type];
         
     DrawTetrad_Special ( (char *)(*(BlocksArray + 
     
                  TetradType *
                  TETRAD_MAX_ROTATIONS
                  + MyDroppingBlock->RotationIndex )).Data,

                  MyDroppingBlock->x, MyDroppingBlock->y,
                  EMPTY_CELL_COLOR );
}

//00000000000000000000000000000000000000000000000000000000000000000000000000
//00000000000000000000000000000000000000000000000000000000000000000000000000
//00000000000000000000000000000000000000000000000000000000000000000000000000
//00000000000000000000000000000000000000000000000000000000000000000000000000

