
#ifndef GAMEIO_DEFINED

     #define GAMEIO_DEFINED

//#include "draw.cpp"

//#include "D:\TIGCC\Projects\Blocks\glob_var.h"

#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\glob_var.h"

//#include "D:\TIGCC\Projects\Blocks\Special.c"
#include "D:\My Documents\TI Calc\Tigcc Projects\Blocks\Special.c"

#include <compat.h>
#include <kbd.h>
#include <sprites.h>

//#include <stdio.h>
//#include <iostream.h>
//#include <dos.h>

/*
#define FIELD_ARRAY_WIDTH  21
#define FIELD_ARRAY_HEIGHT 16

#define FIELD_BORDER_COLOR   8
#define GENERAL_FIELD_CELL_COLOR  7

#define FIELD_X_DISPLACE   80
#define FIELD_Y_DISPLACE   50

#define TETRAD_CELL_WIDTH  4
#define TETRAD_CELL_HEIGHT 4

#define CELL_WIDTH_PIXELS   6
#define CELL_HEIGHT_PIXELS  6

#define INITIALIZE_GAME_KEYS 0
#define GET_GAME_KEYS        1
#define EXIT_GAME_KEYS       2

*/

//0000000000000000000000000000000000000000000000000000000000000000000000000

/*
     struct GameKeys
       {
         char Up, Down, Left, Right;
         char RotateLeft, RotateRight;
         char Pause, Quit;

       };

     struct GameKeys MyGameKeys;

 */

//0000000000000000000000000000000000000000000000000000000000000000000000000

void Draw2dArrayCells ( char *ArrayPtr, short ArrayXsize, short ArrayYsize );

     // uses global data
void DrawCell ( short FieldX, short FieldY, char Color  );

     // uses global data
void DrawCell_XOR ( short FieldX, short FieldY, char Color,
                    void *MyLightLayer, void *MyDarkLayer );

void DrawTetrad ( char *TetradPtr, short x, short y, char ClearColor );

//-------------------------------------------------------------------------

     // uses global data
void DrawCell_Special ( short FieldX, short FieldY, char Color  );

     // uses global data
void DrawCell_XOR_Special ( short FieldX, short FieldY, char Color,
                            void *MyLightLayer, void *MyDarkLayer );

void DrawTetrad_Special ( char *TetradPtr, short x, short y, char ClearColor );

//-------------------------------------------------------------------------

void GetGameKeys ( struct GameKeys *  MyKeys );


//0000000000000000000000000000000000000000000000000000000000000000000000000

void Draw2dArrayCells ( char *ArrayPtr, short ArrayXsize, short ArrayYsize )

{
     short Xindex, Yindex;
     char BlockColor;

     for ( Yindex = 0; Yindex < ArrayYsize; Yindex++ )
        for ( Xindex = 0; Xindex < ArrayXsize; Xindex++ )
            {
              BlockColor = *(ArrayPtr + Xindex + Yindex * ArrayXsize );

              DrawCell ( Xindex, Yindex, BlockColor );

             }
}

//0000000000000000000000000000000000000000000000000000000000000000000000000

void DrawCell ( short FieldX, short FieldY, char Color  )
{

      Sprite8 (FieldX *  CELL_WIDTH_PIXELS, 
               FieldY * CELL_HEIGHT_PIXELS,
               CELL_HEIGHT_PIXELS, 
               
               MyBlockSprites_A[Color].Pic,  // global
               
               DarkLayer, SPRT_OR ); 
 
      Sprite8 (FieldX *  CELL_WIDTH_PIXELS, 
               FieldY * CELL_HEIGHT_PIXELS,
               CELL_HEIGHT_PIXELS, 
               
               MyBlockSprites_B[Color].Pic,  // global
               
               LightLayer, SPRT_OR ); 
}

//0000000000000000000000000000000000000000000000000000000000000000000000000

void DrawCell_XOR ( short FieldX, short FieldY, char Color,
                    void *MyLightLayer, void *MyDarkLayer  )
{

      Sprite8 (FieldX *  CELL_WIDTH_PIXELS, 
               FieldY * CELL_HEIGHT_PIXELS,
               CELL_HEIGHT_PIXELS, 
               
               MyBlockSprites_A[Color].Pic,  // global
               
               MyDarkLayer, SPRT_XOR ); 
 
      Sprite8 (FieldX *  CELL_WIDTH_PIXELS, 
               FieldY * CELL_HEIGHT_PIXELS,
               CELL_HEIGHT_PIXELS, 
               
               MyBlockSprites_B[Color].Pic,  // global
               
               MyLightLayer, SPRT_XOR ); 
}

//0000000000000000000000000000000000000000000000000000000000000000000000000

void DrawTetrad ( char *TetradPtr, short x, short y, char ClearColor )
{
     short  Xd, Yd;
     short Yindex, Xindex;
     char Cell;

    for ( Yindex = 0; Yindex < TETRAD_CELL_WIDTH; Yindex++ )
      for ( Xindex = 0; Xindex < TETRAD_CELL_HEIGHT; Xindex++ )
          {
            Xd = Xindex + x;
            Yd = Yindex + y;

            Cell = *(TetradPtr + Xindex + Yindex * TETRAD_CELL_WIDTH );

            if ( Cell != ClearColor )
              if ( 0 <= Xd && Xd < FIELD_ARRAY_WIDTH &&
                   0 <= Yd && Yd < FIELD_ARRAY_HEIGHT )
                   DrawCell ( Xd, Yd, Cell );
          }
}

//0000000000000000000000000000000000000000000000000000000000000000000000000

void DrawCell_Special ( short FieldX, short FieldY, char Color  )
{
      static short X, Y;
      
      X = DistortXTable[FieldY][FieldX];
      Y = DistortYTable[FieldY][FieldX];

      Color = CellSwapColors[Color];
 
      Sprite8 (X *  CELL_WIDTH_PIXELS, 
               Y * CELL_HEIGHT_PIXELS,
               CELL_HEIGHT_PIXELS, 
               
               MyBlockSprites_A[Color].Pic,  // global
               
               DarkLayer, SPRT_OR ); 
 
      Sprite8 (X *  CELL_WIDTH_PIXELS, 
               Y * CELL_HEIGHT_PIXELS,
               CELL_HEIGHT_PIXELS, 
               
               MyBlockSprites_B[Color].Pic,  // global
               
               LightLayer, SPRT_OR ); 
}

//0000000000000000000000000000000000000000000000000000000000000000000000000

void DrawCell_XOR_Special ( short FieldX, short FieldY, char Color,
                            void *MyLightLayer, void *MyDarkLayer  )
{

      Sprite8 (FieldX *  CELL_WIDTH_PIXELS, 
               FieldY * CELL_HEIGHT_PIXELS,
               CELL_HEIGHT_PIXELS, 
               
               MyBlockSprites_A[Color].Pic,  // global
               
               MyDarkLayer, SPRT_XOR ); 
 
      Sprite8 (FieldX *  CELL_WIDTH_PIXELS, 
               FieldY * CELL_HEIGHT_PIXELS,
               CELL_HEIGHT_PIXELS, 
               
               MyBlockSprites_B[Color].Pic,  // global
               
               MyLightLayer, SPRT_XOR ); 
}

//0000000000000000000000000000000000000000000000000000000000000000000000000

void DrawTetrad_Special ( char *TetradPtr, short x, short y, char ClearColor )
{
     short  Xd, Yd;
     short Yindex, Xindex;
     char Cell;
         
    for ( Yindex = 0; Yindex < TETRAD_CELL_WIDTH; Yindex++ )
      for ( Xindex = 0; Xindex < TETRAD_CELL_HEIGHT; Xindex++ )
          {
            Xd = Xindex + x;
            Yd = Yindex + y;
                       
            Cell = *(TetradPtr + Xindex + Yindex * TETRAD_CELL_WIDTH );

            if ( Cell != ClearColor )  
                 if ( 0 <= Xd && Xd < FIELD_ARRAY_WIDTH &&
                      0 <= Yd && Yd < FIELD_ARRAY_HEIGHT )
                      DrawCell_Special ( Xd, Yd, Cell );
          }    
}

//0000000000000000000000000000000000000000000000000000000000000000000000000

void GetGameKeys ( struct GameKeys *  MyKeys  )
{


   MyKeys->Right = MyKeys->Left =
   MyKeys->Down = MyKeys->RotateLeft =
   MyKeys->RotateRight = MyKeys->Pause =
   MyKeys->Quit = MyKeys->Up =     0;


   if ( _keytest ( RR_LEFT ) )
        MyKeys->Left = 1;
   if ( _keytest ( RR_RIGHT ) )
        MyKeys->Right = 1;
   if ( _keytest ( RR_DOWN )  )
        MyKeys->Down = 1;
        
  if ( !_keytest ( RR_UP ))   // prevent pressing up key from exiting game
   if ( _keytest ( RR_ENTER ) )    // ENTER key
        MyKeys->Quit = 1;
   //if ( _keytest ( RR_UP ) )
   //     MyKeys->Up = 1;
   if ( _keytest ( RR_2ND ) )         // 2ND key
        MyKeys->RotateLeft = 1;
   if ( _keytest ( RR_SHIFT ) )      // Shift key
        MyKeys->RotateRight = 1;
   if ( _keytest ( RR_CLEAR ) )    // Alternative use: Turn on/off next piece
        MyKeys->Pause = 1;
}

//0000000000000000000000000000000000000000000000000000000000000000000000000

/*
void main ()
{
     char Field[FIELD_ARRAY_HEIGHT][FIELD_ARRAY_WIDTH];

     char MyTetrad[][4] = {
                            { 0, 0, 0, 0 },
                            { 0, 2, 0, 0 },
                            { 2, 2, 2, 0 },
                            { 0, 0, 0, 0 },
                          };

     short x, y;

     for ( x = 0; x < FIELD_ARRAY_WIDTH; x++ )
        for ( y = 0; y < FIELD_ARRAY_HEIGHT; y++ )
            Field[y][x] = GENERAL_FIELD_CELL_COLOR;


 SetVideo(0x13);

   GetGameKeys ( MyGameKeys, INITIALIZE_GAME_KEYS );

    x = 10;

   y = -4;

   for ( ;; y++ )
   {

     Draw2dArrayCells ( (char *)Field, FIELD_ARRAY_WIDTH, FIELD_ARRAY_HEIGHT );

     DrawTetrad ( (char *)MyTetrad, x, y, 0  );

     CopyBuffer();

     GetGameKeys ( MyGameKeys, GET_GAME_KEYS );

     if ( MyGameKeys.Left )
          x--;
     if ( MyGameKeys.Right )
          x++;
     if ( MyGameKeys.Quit )
          break;

     if ( y > 14 )
          y = -4;

     delay(100);

   }
     GetGameKeys ( MyGameKeys, EXIT_GAME_KEYS );

     getch();

 RestoreVideo();



}

*/

#endif


